package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
/**
 * auかんたん決済OpenID連携呼出サーブレットサンプルクラス
 */
public class CallAuStartServlet extends HttpServlet {

	private static final String P_START_URL = "StartURL";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_TOKEN = "Token";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        String output = null;

        // パラメータの設定
        String startURL = req.getParameter(P_START_URL);
        String accessid = req.getParameter(P_ACCESS_ID);
        String token = req.getParameter(P_TOKEN);

		print(out, "INPUT: StartURL={0} AccessID={1} Token={2}", new Object[] { startURL, accessid, token });

		try {
			// API呼び出し
			output = client.doAuStart("conf/DoAuStartRedirect.html", startURL, accessid, token, "Windows-31J");
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		print(out, "OUTPUT:");
		out.print(output);
        out.flush();
    }

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
