package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.BankAccountEntryInput;
import com.gmo_pg.g_pay.client.output.BankAccountEntryOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * 口振オンライン申し込み呼出サーブレットサンプルクラス
 */
public class CallBankAccountEntryServlet extends HttpServlet {

	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_MEMBER_NAME = "MemberName";
	private static final String P_CREATE_MEMBER = "CreateMember";
	private static final String P_RET_URL = "RetURL";
	private static final String P_BANK_CODE = "BankCode";
	private static final String P_BRANCH_CODE = "BranchCode";
	private static final String P_ACCOUNT_TYPE = "AccountType";
	private static final String P_ACCOUNT_NUMBER = "AccountNumber";
	private static final String P_ACCOUNT_NAME = "AccountName";
	private static final String P_ACCOUNT_NAME_KANJI = "AccountNameKanji";
	private static final String P_CONSUMER_DEVICE = "ConsumerDevice";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        BankAccountEntryInput input = new BankAccountEntryInput();
        BankAccountEntryOutput output = null;

        // パラメータの設定
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setMemberID(req.getParameter(P_MEMBER_ID));
		input.setMemberName(req.getParameter(P_MEMBER_NAME));
		input.setCreateMember(req.getParameter(P_CREATE_MEMBER));
		input.setRetURL(req.getParameter(P_RET_URL));
		input.setBankCode(req.getParameter(P_BANK_CODE));
		input.setBranchCode(req.getParameter(P_BRANCH_CODE));
		input.setAccountType(req.getParameter(P_ACCOUNT_TYPE));
		input.setAccountNumber(req.getParameter(P_ACCOUNT_NUMBER));
		input.setAccountName(req.getParameter(P_ACCOUNT_NAME));
		input.setAccountNameKanji(req.getParameter(P_ACCOUNT_NAME_KANJI));
		input.setConsumerDevice(req.getParameter(P_CONSUMER_DEVICE));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doBankAccountEntry(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "TranID: {0}", output.getTranID());
			print(out, "Token: {0}", output.getToken());
			print(out, "StartUrl: {0}", output.getStartUrl());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
