package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.BankAccountPaperEntryInput;
import com.gmo_pg.g_pay.client.output.BankAccountPaperEntryOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * 口座振替ペーパー申込口座登録依頼書データ登録呼出サーブレットサンプルクラス
 */
public class CallBankAccountPaperEntryServlet extends HttpServlet {

	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_SHOP_ID = "ShopID";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_MEMBER_NAME = "MemberName";
	private static final String P_FINANCIAL_INSTITUTE_TYPE = "FinancialInstituteType";
	private static final String P_BANK_CODE = "BankCode";
	private static final String P_BRANCH_CODE = "BranchCode";
	private static final String P_ACCOUNT_TYPE = "AccountType";
	private static final String P_ACCOUNT_NUMBER = "AccountNumber";
	private static final String P_POSTAL_ACCOUNT_NUMBER1 = "PostalAccountNumber1";
	private static final String P_POSTAL_ACCOUNT_NUMBER2 = "PostalAccountNumber2";
	private static final String P_ACCOUNT_OWNER_TYPE = "AccountOwnerType";
	private static final String P_ACCOUNT_NAME_SEI = "AccountNameSei";
	private static final String P_ACCOUNT_NAME_MEI = "AccountNameMei";
	private static final String P_ACCOUNT_NAME_SEI_KANA = "AccountNameSeiKana";
	private static final String P_ACCOUNT_NAME_MEI_KANA = "AccountNameMeiKana";
	private static final String P_ACCOUNT_NAME_BISINESS = "AccountNameBisiness";
	private static final String P_ACCOUNT_NAME_BISINESS_KANA = "AccountNameBisinessKana";
	private static final String P_OPERATION_TYPE = "OperationType";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        BankAccountPaperEntryInput input = new BankAccountPaperEntryInput();
        BankAccountPaperEntryOutput output = null;

        // パラメータの設定
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setMemberID(req.getParameter(P_MEMBER_ID));
		input.setMemberName(req.getParameter(P_MEMBER_NAME));
		input.setFinancialInstituteType(req.getParameter(P_FINANCIAL_INSTITUTE_TYPE));
		input.setBankCode(req.getParameter(P_BANK_CODE));
		input.setBranchCode(req.getParameter(P_BRANCH_CODE));
		input.setAccountType(req.getParameter(P_ACCOUNT_TYPE));
		input.setAccountNumber(req.getParameter(P_ACCOUNT_NUMBER));
		input.setPostalAccountNumber1(req.getParameter(P_POSTAL_ACCOUNT_NUMBER1));
		input.setPostalAccountNumber2(req.getParameter(P_POSTAL_ACCOUNT_NUMBER2));
		input.setAccountOwnerType(req.getParameter(P_ACCOUNT_OWNER_TYPE));
		input.setAccountNameSei(req.getParameter(P_ACCOUNT_NAME_SEI));
		input.setAccountNameMei(req.getParameter(P_ACCOUNT_NAME_MEI));
		input.setAccountNameSeiKana(req.getParameter(P_ACCOUNT_NAME_SEI_KANA));
		input.setAccountNameMeiKana(req.getParameter(P_ACCOUNT_NAME_MEI_KANA));
		input.setAccountNameBisiness(req.getParameter(P_ACCOUNT_NAME_BISINESS));
		input.setAccountNameBisinessKana(req.getParameter(P_ACCOUNT_NAME_BISINESS_KANA));
		input.setOperationType(req.getParameter(P_OPERATION_TYPE));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doBankAccountPaperEntry(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "TranID: {0}", output.getTranID());
			print(out, "SiteID: {0}", output.getSiteID());
			print(out, "MemberID: {0}", output.getMemberID());
			print(out, "AccountSeq: {0}", output.getAccountSeq());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
