package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.BankAccountTranResultInput;
import com.gmo_pg.g_pay.client.output.BankAccountTranResultOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * 口振オンライン口座振替申込トランザクション状態照会呼出サーブレットサンプルクラス
 */
public class CallBankAccountTranResultServlet extends HttpServlet {

	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_TRAN_ID = "TranID";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        BankAccountTranResultInput input = new BankAccountTranResultInput();
        BankAccountTranResultOutput output = null;

        // パラメータの設定
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setTranID(req.getParameter(P_TRAN_ID));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doBankAccountTranResult(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "SiteID: {0}", output.getSiteID());
			print(out, "MemberID: {0}", output.getMemberID());
			print(out, "TranID: {0}", output.getTranID());
			print(out, "Status: {0}", output.getStatus());
			print(out, "BankCode: {0}", output.getBankCode());
			print(out, "BranchCode: {0}", output.getBranchCode());
			print(out, "AccountType: {0}", output.getAccountType());
			print(out, "AccountNumber: {0}", output.getAccountNumber());
			print(out, "AccountName: {0}", output.getAccountName());
			print(out, "AccountIdentification: {0}", output.getAccountIdentification());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
