package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.AcsParam;

/**
 * リダイレクトページ作成呼出サーブレットサンプルクラス
 */
public class CallCreateRedirectPageServlet extends HttpServlet {

	private static final String P_PA_REQ = "PaReq";
	private static final String P_MD = "MD";
	private static final String P_ACS_URL = "ACSUrl";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		AcsParam input = new AcsParam();
		String output = null;

		// パラメータの設定
        input.setAcsUrl(req.getParameter(P_ACS_URL));
        input.setPaReq(req.getParameter(P_PA_REQ));
        input.setTermUrl("http://localhost:8080/callSecureTran");
        input.setMd(req.getParameter(P_MD));
		print(out, "INPUT");
		print(out, "ACSUrl: {0}", input.getAcsUrl());
		print(out, "PaReq: {0}", input.getPaReq());
		print(out, "TermUrl: {0}", input.getTermUrl());
		print(out, "MD: {0}", input.getMd());

		try {
			// API呼び出し
			output = client.createRedirectPage("conf/RedirectPage.html", input, "Windows-31J");
		} catch (PaymentException e) {
			e.printStackTrace();
			print(out, "ERROR:");
			print(out, e.getMessage());
			out.flush();
			return;
		}

		// 結果出力
		print(out, "OUTPUT:");
        print(out, output);
		out.flush();
}

	private void print(PrintWriter out, String str) {
		System.out.println(str);
		out.print(str);
		out.println();
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}