package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.DocomoContinuanceUserEndInput;
import java.util.Iterator;
import java.util.List;

import com.gmo_pg.g_pay.client.output.DocomoContinuanceUserEndOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;


/**
 * ドコモ継続決済　継続課金終了(お客様)呼出サーブレットサンプルクラス
 */
public class CallDocomoContinuanceUserEndServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_AMOUNT = "Amount";
	private static final String P_TAX = "Tax";
	private static final String P_DOCOMO_DISP1 = "DocomoDisp1";
	private static final String P_DOCOMO_DISP2 = "DocomoDisp2";
	private static final String P_RET_URL = "RetURL";
	private static final String P_PAYMENT_TERM_SEC = "PaymentTermSec";
	private static final String P_LAST_MONTH_FREE_FLAG = "LastMonthFreeFlag";




	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {

    req.setCharacterEncoding("windows-31j");
    res.setContentType("text/html; charset=windows-31j");
    PrintWriter out = res.getWriter();

    PaymentClientImpl client = new PaymentClientImpl();
    DocomoContinuanceUserEndInput input = new DocomoContinuanceUserEndInput();
    DocomoContinuanceUserEndOutput output = null;

    // パラメータの設定
	input.setShopID(req.getParameter(P_SHOP_ID));
	input.setShopPass(req.getParameter(P_SHOP_PASS));
	input.setAccessID(req.getParameter(P_ACCESS_ID));
	input.setAccessPass(req.getParameter(P_ACCESS_PASS));

	input.setOrderID(req.getParameter(P_ORDER_ID));
	input.setAmount(
			req.getParameter(P_AMOUNT) == null || req.getParameter(P_AMOUNT).length() == 0
				? null : Integer.valueOf(req.getParameter(P_AMOUNT)));
	input.setTax(
			req.getParameter(P_TAX) == null || req.getParameter(P_TAX).length() == 0
				? null : Integer.valueOf(req.getParameter(P_TAX)));

	input.setDocomoDisp1(req.getParameter(P_DOCOMO_DISP1));
	input.setDocomoDisp2(req.getParameter(P_DOCOMO_DISP2));
	input.setRetURL(req.getParameter(P_RET_URL));
	input.setPaymentTermSec(
			req.getParameter(P_PAYMENT_TERM_SEC) == null || req.getParameter(P_PAYMENT_TERM_SEC).length() == 0
				? null : Integer.valueOf(req.getParameter(P_PAYMENT_TERM_SEC)));

	input.setLastMonthFreeFlag(Integer.valueOf(req.getParameter(P_LAST_MONTH_FREE_FLAG)));


   	print(out, "INPUT: {0}", input.toDataString(false));

	try {
		// API呼び出し
		output = client.doDocomoContinuanceUserEnd(input);
	} catch (PaymentException e) {
		//
		// [注意事項]
		// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
		//
		e.printStackTrace();
		throw new ServletException(e);
	}

	// 結果確認
	if (output.isErrorOccurred()) {
		List list = output.getErrList();
		print(out, "ERROR:");
		for(Iterator it = list.iterator(); it.hasNext();) {
			ErrHolder eh = (ErrHolder)it.next();
			print(out, "ErrorCode: {0}  ErrorInfo: {1}",
					new Object[]{eh.getErrCode(), eh.getErrInfo()});

		}
	} else {
		print(out, "OUTPUT:");
		print(out, "AccessID: {0}", output.getAccessID());
		print(out, "Token: {0}", output.getToken());
		print(out, "StartURL: {0}", output.getStartURL());
		print(out, "StartLimitDate: {0}", output.getStartLimitDate());


	}
    out.flush();
}

private void print(PrintWriter out, String str) {
	print(out, str, null);
}

private void print(PrintWriter out, String fmt, Object obj) {
	print(out, fmt, new Object[]{obj});
}

private void print(PrintWriter out, String fmt, Object[] obj) {
	System.out.println(MessageFormat.format(fmt,obj));
	out.print(MessageFormat.format(fmt,obj));
	out.print("<br>");
	out.println();
}
}