package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.common.util.CommonUtil;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.EntryExecTranAuContinuanceInput;
import com.gmo_pg.g_pay.client.output.EntryExecTranAuContinuanceOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;

/**
 * auかんたん決済継続課金登録・決済呼出サーブレットサンプルクラス
 */
public class CallEntryExecTranAuContinuanceServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_AMOUNT = "Amount";
	private static final String P_TAX = "Tax";
	private static final String P_FIRSTAMOUNT = "FirstAmount";
	private static final String P_FIRSTTAX = "FirstTax";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_MEMBER_NAME = "MemberName";
	private static final String P_CREATE_MEMBER = "CreateMember";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_COMMODITY = "Commodity";
	private static final String P_ACCOUNT_TIMING_KBN = "AccountTimingKbn";
	private static final String P_ACCOUNT_TIMING = "AccountTiming";
	private static final String P_FIRST_ACCOUNT_DATE = "FirstAccountDate";
	private static final String P_RET_URL = "RetURL";
	private static final String P_PAYMENT_TERM_SEC = "PaymentTermSec";
	private static final String P_SERVICE_NAME = "ServiceName";
	private static final String P_SERVICE_TEL = "ServiceTel";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		EntryExecTranAuContinuanceInput input = new EntryExecTranAuContinuanceInput();
		EntryExecTranAuContinuanceOutput output = null;

		// パラメータの設定
        input.setShopID(req.getParameter(P_SHOP_ID));
        input.setShopPass(req.getParameter(P_SHOP_PASS));
        input.setOrderID(req.getParameter(P_ORDER_ID));

        String tmp = req.getParameter(P_AMOUNT);
        if(CommonUtil.isNotEmpty(tmp)){
        	input.setAmount(Integer.valueOf(tmp));
        }
        tmp = req.getParameter(P_TAX);
        if(CommonUtil.isNotEmpty(tmp)){
        	input.setTax(Integer.valueOf(tmp));
        }
        tmp = req.getParameter(P_FIRSTAMOUNT);
        if(CommonUtil.isNotEmpty(tmp)){
        	input.setFirstAmount(Integer.valueOf(tmp));
        }
        tmp = req.getParameter(P_FIRSTTAX);
        if(CommonUtil.isNotEmpty(tmp)){
        	input.setFirstTax(Integer.valueOf(tmp));
        }
        input.setAccessID(req.getParameter(P_ACCESS_ID));
        input.setAccessPass(req.getParameter(P_ACCESS_PASS));
        input.setSiteID(req.getParameter(P_SITE_ID));
        input.setSitePass(req.getParameter(P_SITE_PASS));
        input.setMemberID(req.getParameter(P_MEMBER_ID));
        input.setMemberName(req.getParameter(P_MEMBER_NAME));
        input.setCreateMember(req.getParameter(P_CREATE_MEMBER));
        input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
        input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
        input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
        input.setCommodity(req.getParameter(P_COMMODITY));
        input.setAccountTimingKbn(req.getParameter(P_ACCOUNT_TIMING_KBN));
        input.setAccountTiming(req.getParameter(P_ACCOUNT_TIMING));
        input.setFirstAccountDate(req.getParameter(P_FIRST_ACCOUNT_DATE));
        input.setRetURL(req.getParameter(P_RET_URL));
        input.setPaymentTermSec(
        		req.getParameter(P_PAYMENT_TERM_SEC) == null
        			? null : Integer.valueOf(req.getParameter(P_PAYMENT_TERM_SEC)));
        input.setServiceName(req.getParameter(P_SERVICE_NAME));
        input.setServiceTel(req.getParameter(P_SERVICE_TEL));
		print(out, "INPUT(Entry): {0}",
				input.getEntryTranInput().toDataString(false));
		print(out, "INPUT(Exec): {0}",
				input.getExecTranInput().toDataString(false));

		try {
			// API呼び出し
			output = client.doEntryExecTranAuContinuance(input);
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			if (output.isEntryErrorOccurred()) {
				List list = output.getEntryErrList();
				print(out, "ERROR(EntryTran):");
				for(Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder)it.next();
					print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
									new Object[]{eh.getErrCode(), eh.getErrInfo()}));
				}
			}
			if (output.isExecErrorOccurred()) {
				List list = output.getExecErrList();
				print(out, "ERROR(ExecTran):");
				for(Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder)it.next();
					print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
									new Object[]{eh.getErrCode(), eh.getErrInfo()}));
				}
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "AccessID: {0}", output.getAccessID());
			print(out, "AccessPass: {0}", output.getAccessPass());
			print(out, "Token: {0}", output.getToken());
			print(out, "StartURL: {0}", output.getStartURL());
			print(out, "StartLimitDate: {0}", output.getStartLimitDate());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
