package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.EntryExecTranMerpayInput;
import com.gmo_pg.g_pay.client.output.EntryExecTranMerpayOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * メルペイ登録・決済呼出サーブレットサンプルクラス
 */
public class CallEntryExecTranMerpayServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_JOB_CD = "JobCd";
	private static final String P_AMOUNT = "Amount";
	private static final String P_TAX = "Tax";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_DELIVERY_ADDRESS_FLAG = "DeliveryAddressFlag";
	private static final String P_ITEM_NAME = "ItemName";
	private static final String P_ITEM_DESCRIPTION = "ItemDescription";
	private static final String P_ITEM_IMAGE_URL1 = "ItemImageUrl1";
	private static final String P_ITEM_IMAGE_URL2 = "ItemImageUrl2";
	private static final String P_ITEM_IMAGE_URL3 = "ItemImageUrl3";
	private static final String P_ITEM_IMAGE_URL4 = "ItemImageUrl4";
	private static final String P_ITEM_IMAGE_URL5 = "ItemImageUrl5";
	private static final String P_ITEM_IMAGE_URL6 = "ItemImageUrl6";
	private static final String P_ITEM_IMAGE_URL7 = "ItemImageUrl7";
	private static final String P_ITEM_IMAGE_URL8 = "ItemImageUrl8";
	private static final String P_ITEM_IMAGE_URL9 = "ItemImageUrl9";
	private static final String P_ITEM_CATEGORY = "ItemCategory";
	private static final String P_ITEM_SIZE = "ItemSize";
	private static final String P_ITEM_BRAND = "ItemBrand";
	private static final String P_ITEM_COLOR = "ItemColor";
	private static final String P_ITEM_LIST_PRICE = "ItemListPrice";
	private static final String P_ITEM_UNIT_PRICE = "ItemUnitPrice";
	private static final String P_ITEM_QUANTITY = "ItemQuantity";
	private static final String P_ITEM_ITEM_CODE = "ItemItemCode";
	private static final String P_ITEM_JAN_CODE = "ItemJanCode";
	private static final String P_ITEM_CATEGORY_ID = "ItemCategoryId";
	private static final String P_MULTI_ITEM = "MultiItem";
	private static final String P_HTTP_USER_AGENT = "HttpUserAgent";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_TAX_CALC_URL = "TaxCalcURL";
	private static final String P_RET_URL = "RetURL";
	private static final String P_USER_INFO = "UserInfo";
	private static final String P_SUBSCRIPTION_TYPE = "SubscriptionType";
	private static final String P_SUBSCRIPTION_NAME = "SubscriptionName";
	private static final String P_SUBSCRIPTION_DESCRIPTION = "SubscriptionDescription";
	private static final String P_SETTLEMENT_SUBSCRIPTION_ID = "SettlementSubscriptionId";

	
	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		EntryExecTranMerpayInput input = new EntryExecTranMerpayInput();
		EntryExecTranMerpayOutput output = null;

		// パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setJobCd(req.getParameter(P_JOB_CD));
		input.setAmount(
				req.getParameter(P_AMOUNT) == null || req.getParameter(P_AMOUNT).length() == 0
					? null : new Integer(req.getParameter(P_AMOUNT)));

		input.setTax(
				req.getParameter(P_TAX) == null || req.getParameter(P_TAX).length() == 0
					? null : new Integer(req.getParameter(P_TAX)));

		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setDeliveryAddressFlag(req.getParameter(P_DELIVERY_ADDRESS_FLAG));
		input.setItemName(req.getParameter(P_ITEM_NAME));
		input.setItemDescription(req.getParameter(P_ITEM_DESCRIPTION));
		input.setItemImageUrl1(req.getParameter(P_ITEM_IMAGE_URL1));
		input.setItemImageUrl2(req.getParameter(P_ITEM_IMAGE_URL2));
		input.setItemImageUrl3(req.getParameter(P_ITEM_IMAGE_URL3));
		input.setItemImageUrl4(req.getParameter(P_ITEM_IMAGE_URL4));
		input.setItemImageUrl5(req.getParameter(P_ITEM_IMAGE_URL5));
		input.setItemImageUrl6(req.getParameter(P_ITEM_IMAGE_URL6));
		input.setItemImageUrl7(req.getParameter(P_ITEM_IMAGE_URL7));
		input.setItemImageUrl8(req.getParameter(P_ITEM_IMAGE_URL8));
		input.setItemImageUrl9(req.getParameter(P_ITEM_IMAGE_URL9));
		input.setItemCategory(req.getParameter(P_ITEM_CATEGORY));
		input.setItemSize(req.getParameter(P_ITEM_SIZE));
		input.setItemBrand(req.getParameter(P_ITEM_BRAND));
		input.setItemColor(req.getParameter(P_ITEM_COLOR));
		input.setItemListPrice(req.getParameter(P_ITEM_LIST_PRICE));
		input.setItemUnitPrice(req.getParameter(P_ITEM_UNIT_PRICE));
		input.setItemQuantity(req.getParameter(P_ITEM_QUANTITY));
		input.setItemItemCode(req.getParameter(P_ITEM_ITEM_CODE));
		input.setItemJanCode(req.getParameter(P_ITEM_JAN_CODE));
		input.setItemCategoryId(req.getParameter(P_ITEM_CATEGORY_ID));
		input.setMultiItem(req.getParameter(P_MULTI_ITEM));
		input.setHttpUserAgent(req.getParameter(P_HTTP_USER_AGENT));
		input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
		input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setTaxCalcURL(req.getParameter(P_TAX_CALC_URL));
		input.setRetURL(req.getParameter(P_RET_URL));
		input.setUserInfo(req.getParameter(P_USER_INFO));
		input.setSubscriptionType(req.getParameter(P_SUBSCRIPTION_TYPE));
		input.setSubscriptionName(req.getParameter(P_SUBSCRIPTION_NAME));
		input.setSubscriptionDescription(req.getParameter(P_SUBSCRIPTION_DESCRIPTION));
		input.setSettlementSubscriptionId(req.getParameter(P_SETTLEMENT_SUBSCRIPTION_ID));

		print(out, "INPUT(Entry): {0}",
				input.getEntryTranInput().toDataString(false));
		print(out, "INPUT(Exec): {0}",
				input.getExecTranInput().toDataString(false));

		try {
			// API呼び出し
			output = client.doEntryExecTranMerpay(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			if (output.isEntryErrorOccurred()) {
				List list = output.getEntryErrList();
				print(out, "ERROR(EntryTran):");
				for(Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder)it.next();
					print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
									new Object[]{eh.getErrCode(), eh.getErrInfo()}));
				}
			}
			if (output.isExecErrorOccurred()) {
				List list = output.getExecErrList();
				print(out, "ERROR(ExecTran):");
				for(Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder)it.next();
					print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
									new Object[]{eh.getErrCode(), eh.getErrInfo()}));
				}
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "AccessID: {0}", output.getAccessID());
			print(out, "AccessPass: {0}", output.getAccessPass());
			print(out, "AccessID: {0}", output.getAccessID());
			print(out, "Token: {0}", output.getToken());
			print(out, "StartURL: {0}", output.getStartURL());
			print(out, "ShopID: {0}", output.getShopID());
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "Status: {0}", output.getStatus());
			print(out, "TranDate: {0}", output.getTranDate());
			print(out, "CheckString: {0}", output.getCheckString());


		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
