package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.Method;
import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.EntryExecTranInput;
import com.gmo_pg.g_pay.client.input.EntryExecTranPaypalInput;
import com.gmo_pg.g_pay.client.output.EntryExecTranOutput;
import com.gmo_pg.g_pay.client.output.EntryExecTranPaypalOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;

/**
 * Paypal取引登録・決済実行呼出サーブレットサンプルクラス
 */
public class CallEntryExecTranPaypalServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_JOB_CD = "JobCd";
	private static final String P_CURRENCY = "Currency";
	private static final String P_AMOUNT = "Amount";
	private static final String P_TAX = "Tax";
	private static final String P_ITEM_NAME = "ItemName";
	private static final String P_REDIRECT_URL = "RedirectURL";
	private static final String P_LOCALE = "Locale";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_CLIENT_FIELD_FLAG = "ClientFieldFlag";
	private static final String P_PAYMENT_TYPE = "PaymentType";
	private static final String P_PAYPAL_BILLING_AGREEMENT_ID = "PaypalBillingAgreementID";
	private static final String P_SHIP_FLG = "ShipFlg";
	private static final String P_SHIP_TO_NAME = "ShipToName";
	private static final String P_SHIP_TO_ZIP = "ShipToZip";
	private static final String P_SHIP_TO_COUNTRY_CODE = "ShipToCountryCode";
	private static final String P_SHIP_TO_STATE = "ShipToState";
	private static final String P_SHIP_TO_CITY = "ShipToCity";
	private static final String P_SHIP_TO_STREET = "ShipToStreet";
	private static final String P_SHIP_TO_STREET2 = "ShipToStreet2";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		EntryExecTranPaypalInput input = new EntryExecTranPaypalInput();
		EntryExecTranPaypalOutput output = null;

		// パラメータの設定
		input.setShopId(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setOrderId(req.getParameter(P_ORDER_ID));
		input.setJobCd(req.getParameter(P_JOB_CD));
		input.setCurrency(req.getParameter(P_CURRENCY));
		input.setAmount(req.getParameter(P_AMOUNT) == null ? null : Integer
				.valueOf(req.getParameter(P_AMOUNT)));
		input.setTax(req.getParameter(P_TAX) == null ? null : Integer
				.valueOf(req.getParameter(P_TAX)));
		input.setItemName(req.getParameter(P_ITEM_NAME));
		input.setRedirectURL(req.getParameter(P_REDIRECT_URL));
		input.setLocale(req.getParameter(P_LOCALE));
		input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
		input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setClientFieldFlag(req.getParameter(P_CLIENT_FIELD_FLAG));
		input.setPaymentType(req.getParameter(P_PAYMENT_TYPE));
		input.setPaypalBillingAgreementId(req.getParameter(P_PAYPAL_BILLING_AGREEMENT_ID));
		input.setShipFlg(req.getParameter(P_SHIP_FLG));
		input.setShipToName(req.getParameter(P_SHIP_TO_NAME));
		input.setShipToZip(req.getParameter(P_SHIP_TO_ZIP));
		input.setShipToCountryCode(req.getParameter(P_SHIP_TO_COUNTRY_CODE));
		input.setShipToState(req.getParameter(P_SHIP_TO_STATE));
		input.setShipToCity(req.getParameter(P_SHIP_TO_CITY));
		input.setShipToStreet(req.getParameter(P_SHIP_TO_STREET));
		input.setShipToStreet2(req.getParameter(P_SHIP_TO_STREET2));
		print(out, "INPUT(Entry): {0}", input.getEntryTranPaypalInput()
				.toDataString(false));
		print(out, "INPUT(Exec): {0}", input.getExecTranPaypalInput()
				.toDataString(false));

		try {
			// API呼び出し
			output = client.doEntryExecTranPaypal(input);
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			if (output.isEntryErrorOccurred()) {
				List list = output.getEntryErrList();
				print(out, "ERROR(EntryTran):");
				for (Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder) it.next();
					print(out, MessageFormat.format(
							"ErrorCode: {0}  ErrorInfo: {1}", new Object[] {
									eh.getErrCode(), eh.getErrInfo() }));
				}
			}
			if (output.isExecErrorOccurred()) {
				List list = output.getExecErrList();
				print(out, "ERROR(ExecTran):");
				for (Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder) it.next();
					print(out, MessageFormat.format(
							"ErrorCode: {0}  ErrorInfo: {1}", new Object[] {
									eh.getErrCode(), eh.getErrInfo() }));
				}
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "OrderID {0}", output.getOrderId());
			print(out, "AccessID: {0}", output.getAccessId());
			print(out, "AccessPass: {0}", output.getAccessPass());
			print(out, "ClientField1: {0}", output.getClientField1());
			print(out, "ClientField2: {0}", output.getClientField2());
			print(out, "ClientField3: {0}", output.getClientField3());
			print(out, "ShopID: {0}", output.getShopId());
			print(out, "Status: {0}", output.getStatus());
			print(out, "TranDate: {0}", output.getTranDate());
			print(out, "TranID: {0}", output.getTranId());
			print(out, "CheckString: {0}", output.getCheckString());
		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[] { obj });
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt, obj));
		out.print(MessageFormat.format(fmt, obj));
		out.print("<br>");
		out.println();
	}
}
