package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.EntryExecTranPaysleInput;
import com.gmo_pg.g_pay.client.output.EntryExecTranPaysleOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * Paysle登録・決済呼出サーブレットサンプルクラス
 */
public class CallEntryExecTranPaysleServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_AMOUNT = "Amount";
	private static final String P_TAX = "Tax";
	private static final String P_PAYMENT_TYPE = "PaymentType";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_DISPLAY_TERM_DAY = "DisplayTermDay";
	private static final String P_PAYMENT_TERM_DAY = "PaymentTermDay";
	private static final String P_NOTIFY_TERM_DAY = "NotifyTermDay";
	private static final String P_CUSTOMER_NAME = "CustomerName";
	private static final String P_CUSTOMER_TEL = "CustomerTel";
	private static final String P_CUSTOMER_ID = "CustomerId";
	private static final String P_INVOICE_TITLE = "InvoiceTitle";
	private static final String P_ITEM_ID = "ItemId";
	private static final String P_ITEM_NAME = "ItemName";
	private static final String P_MULTI_ITEM = "MultiItem";
	private static final String P_ITEM_NUMBERS = "ItemNumbers";
	private static final String P_ITEM_FEE = "ItemFee";
	private static final String P_PAYSLE_TAX = "PaysleTax";
	private static final String P_PAYSLE_SHIPPING_FEE = "PaysleShippingFee";
	private static final String P_DEVICE_NAME = "DeviceName";
	private static final String P_OS_VERSION = "OsVersion";
	private static final String P_WIN_WIDTH = "WinWidth";
	private static final String P_WIN_HEIGHT = "WinHeight";
	private static final String P_XDPI = "Xdpi";
	private static final String P_YDPI = "Ydpi";

	
	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		EntryExecTranPaysleInput input = new EntryExecTranPaysleInput();
		EntryExecTranPaysleOutput output = null;

		// パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setAmount(
				req.getParameter(P_AMOUNT) == null || req.getParameter(P_AMOUNT).length() == 0
					? null : new Integer(req.getParameter(P_AMOUNT)));

		input.setTax(
				req.getParameter(P_TAX) == null || req.getParameter(P_TAX).length() == 0
					? null : new Integer(req.getParameter(P_TAX)));

		input.setPaymentType(req.getParameter(P_PAYMENT_TYPE));
		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
		input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setDisplayTermDay(req.getParameter(P_DISPLAY_TERM_DAY));
		input.setPaymentTermDay(req.getParameter(P_PAYMENT_TERM_DAY));
		input.setNotifyTermDay(req.getParameter(P_NOTIFY_TERM_DAY));
		input.setCustomerName(req.getParameter(P_CUSTOMER_NAME));
		input.setCustomerTel(req.getParameter(P_CUSTOMER_TEL));
		input.setCustomerId(req.getParameter(P_CUSTOMER_ID));
		input.setInvoiceTitle(req.getParameter(P_INVOICE_TITLE));
		input.setItemId(req.getParameter(P_ITEM_ID));
		input.setItemName(req.getParameter(P_ITEM_NAME));
		input.setMultiItem(req.getParameter(P_MULTI_ITEM));
		input.setItemNumbers(
				req.getParameter(P_ITEM_NUMBERS) == null || req.getParameter(P_ITEM_NUMBERS).length() == 0
					? null : new Integer(req.getParameter(P_ITEM_NUMBERS)));

		input.setItemFee(
				req.getParameter(P_ITEM_FEE) == null || req.getParameter(P_ITEM_FEE).length() == 0
					? null : new Integer(req.getParameter(P_ITEM_FEE)));

		input.setPaysleTax(
				req.getParameter(P_PAYSLE_TAX) == null || req.getParameter(P_PAYSLE_TAX).length() == 0
					? null : new Integer(req.getParameter(P_PAYSLE_TAX)));

		input.setPaysleShippingFee(
				req.getParameter(P_PAYSLE_SHIPPING_FEE) == null || req.getParameter(P_PAYSLE_SHIPPING_FEE).length() == 0
					? null : new Integer(req.getParameter(P_PAYSLE_SHIPPING_FEE)));

		input.setDeviceName(req.getParameter(P_DEVICE_NAME));
		input.setOsVersion(req.getParameter(P_OS_VERSION));
		input.setWinWidth(
				req.getParameter(P_WIN_WIDTH) == null || req.getParameter(P_WIN_WIDTH).length() == 0
					? null : new Integer(req.getParameter(P_WIN_WIDTH)));

		input.setWinHeight(
				req.getParameter(P_WIN_HEIGHT) == null || req.getParameter(P_WIN_HEIGHT).length() == 0
					? null : new Integer(req.getParameter(P_WIN_HEIGHT)));

		input.setXdpi(
				req.getParameter(P_XDPI) == null || req.getParameter(P_XDPI).length() == 0
					? null : new Integer(req.getParameter(P_XDPI)));

		input.setYdpi(
				req.getParameter(P_YDPI) == null || req.getParameter(P_YDPI).length() == 0
					? null : new Integer(req.getParameter(P_YDPI)));


		print(out, "INPUT(Entry): {0}",
				input.getEntryTranInput().toDataString(false));
		print(out, "INPUT(Exec): {0}",
				input.getExecTranInput().toDataString(false));

		try {
			// API呼び出し
			output = client.doEntryExecTranPaysle(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			if (output.isEntryErrorOccurred()) {
				List list = output.getEntryErrList();
				print(out, "ERROR(EntryTran):");
				for(Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder)it.next();
					print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
									new Object[]{eh.getErrCode(), eh.getErrInfo()}));
				}
			}
			if (output.isExecErrorOccurred()) {
				List list = output.getExecErrList();
				print(out, "ERROR(ExecTran):");
				for(Iterator it = list.iterator(); it.hasNext();) {
					ErrHolder eh = (ErrHolder)it.next();
					print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
									new Object[]{eh.getErrCode(), eh.getErrInfo()}));
				}
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "AccessID: {0}", output.getAccessID());
			print(out, "AccessPass: {0}", output.getAccessPass());
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "Status: {0}", output.getStatus());
			print(out, "TranDate: {0}", output.getTranDate());
			print(out, "PaysleDisplayTerm: {0}", output.getPaysleDisplayTerm());
			print(out, "PayslePaymentTerm: {0}", output.getPayslePaymentTerm());
			print(out, "PaysleNotifyTerm: {0}", output.getPaysleNotifyTerm());
			print(out, "CheckString: {0}", output.getCheckString());
			print(out, "PaysleOrderSerial: {0}", output.getPaysleOrderSerial());
			print(out, "PaysleBarcodeWidth: {0}", output.getPaysleBarcodeWidth());
			print(out, "PaysleBarcodeHeight: {0}", output.getPaysleBarcodeHeight());
			print(out, "PaysleBarcodeFormat: {0}", output.getPaysleBarcodeFormat());
			print(out, "PaysleBarcode: {0}", output.getPaysleBarcode());


		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
