package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.ExecFraudScreeningInput;
import com.gmo_pg.g_pay.client.input.ExecFraudScreeningInput.RedItemHolder;
import com.gmo_pg.g_pay.client.output.ErrHolder;
import com.gmo_pg.g_pay.client.output.ExecFraudScreeningOutput;

/**
 * 不正防止実行呼出サーブレットサンプルクラス
 */
public class CallExecFraudScreeningServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_EXEC_MODE = "ExecMode";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_RED_AMT = "RedAmt";
	private static final String P_RED_CURR_CD ="RedCurrCd";
	private static final String P_RED_ACCT_NUM = "RedAcctNum";
	private static final String P_RED_CARD_EXP_DT = "RedCardExpDt";
	private static final String P_RED_CUST_TYPE_CD = "RedCustTypeCd";
	private static final String P_RED_CUST_ID = "RedCustId";
	private static final String P_RED_CUST_FNAME = "RedCustFname";
	private static final String P_RED_CUST_LNAME = "RedCustLname";
	private static final String P_RED_CUST_ADDR1 = "RedCustAddr1";
	private static final String P_RED_CUST_ADDR2 = "RedCustAddr2";
	private static final String P_RED_CUST_ADDR3 = "RedCustAddr3";
	private static final String P_RED_CUST_CITY = "RedCustCity";
	private static final String P_RED_CUST_POSTAL_CD = "RedCustPostalCd";
	private static final String P_RED_CUST_CNTRY_CD = "RedCustCntryCd";
	private static final String P_RED_CUST_HOME_PHONE = "RedCustHomePhone";
	private static final String P_RED_CUST_EMAIL = "RedCustEmail";
	private static final String P_RED_CUST_IP_ADDR = "RedCustIpAddr";
	private static final String P_RED_EBT_PREVCUST = "RedEbtPrevcust";
	private static final String P_RED_EBT_TOF = "RedEbtTof";
	private static final String P_RED_SHIP_TYPE_CD = "RedShipTypeCd";
	private static final String P_RED_SHIP_FNAME = "RedShipFname";
	private static final String P_RED_SHIP_LNAME = "RedShipLname";
	private static final String P_RED_SHIP_ADDR1 = "RedShipAddr1";
	private static final String P_RED_SHIP_ADDR2 = "RedShipAddr2";
	private static final String P_RED_SHIP_ADDR3 = "RedShipAddr3";
	private static final String P_RED_SHIP_CITY = "RedShipCity";
	private static final String P_RED_SHIP_POSTAL_CD = "RedShipPostalCd";
	private static final String P_RED_EMP_COMPANY = "RedEmpCompany";
	private static final String P_RED_EBT_DEVICEPRINT = "RedEbtDeviceprint";
	private static final String P_RED_EBT_USER_DATA8 = "RedEbtUserData8";
	private static final String P_RED_EBT_USER_DATA9 = "RedEbtUserData9";
	private static final String P_RED_EBT_USER_DATA11 = "RedEbtUserData11";
	private static final String P_RED_EBT_USER_DATA12 = "RedEbtUserData12";
	private static final String P_RED_EBT_USER_DATA13 = "RedEbtUserData13";
	private static final String P_RED_EBT_USER_DATA15 = "RedEbtUserData15";
	private static final String P_RED_EBT_USER_DATA16 = "RedEbtUserData16";
	private static final String P_RED_EBT_USER_DATA17 = "RedEbtUserData17";
	private static final String P_RED_EBT_USER_DATA18 = "RedEbtUserData18";
	private static final String P_RED_EBT_USER_DATA19 = "RedEbtUserData19";
	private static final String P_RED_EBT_USER_DATA20 = "RedEbtUserData20";
	private static final String P_RED_EBT_USER_DATA21 = "RedEbtUserData21";
	private static final String P_RED_EBT_USER_DATA22 = "RedEbtUserData22";
	private static final String P_RED_EBT_USER_DATA23 = "RedEbtUserData23";
	private static final String P_RED_EBT_USER_DATA24 = "RedEbtUserData24";
	private static final String P_RED_EBT_USER_DATA25 = "RedEbtUserData25";
	private static final String P_RED_ITEM_QTY = "RedItemQty";
	private static final String P_RED_ITEM_PROD_CD = "RedItemProdCd";
	private static final String P_RED_ITEM_MAN_PART_NO = "RedItemManPartNo";
	private static final String P_RED_ITEM_DESC = "RedItemDesc";
	private static final String P_RED_EBT_ITEM_CST = "RedEbtItemCst";
	private static final String P_RED_ITEM_GIFT_MSG = "RedItemGiftMsg";
	private static final String P_TELEGRAM_TYPE = "TelegramType";
	private static final String P_TOKEN = "Token";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_SEQ_MODE = "SeqMode";
	private static final String P_CARD_SEQ = "CardSeq";
	private static final String P_RED_ORD_ID = "RedOrdId";
	private static final String P_RED_CUST_MNAME = "RedCustMname";
	private static final String P_RED_CUST_GENDER = "RedCustGender";
	private static final String P_RED_CUST_WORK_PHONE = "RedCustWorkPhone";
	private static final String P_RED_CUST_BIRTH_DT = "RedCustBirthDt";
	private static final String P_RED_CUST_MOBILE_PHONE = "RedCustMobilePhone";
	private static final String P_RED_CUST_DOC_TYPE = "RedCustDocType";
	private static final String P_RED_CUST_DOC_ID = "RedCustDocId";
	private static final String P_RED_CUST_STPR_CD = "RedCustStprCd";
	private static final String P_RED_SHIP_MNAME = "RedShipMname";
	private static final String P_RED_SHIP_STPR_CD = "RedShipStprCd";
	private static final String P_RED_SHIP_CNTRY_CD = "RedShipCntryCd";
	private static final String P_RED_SHIP_EMAIL = "RedShipEmail";
	private static final String P_RED_SHIP_HOME_PHONE = "RedShipHomePhone";
	private static final String P_RED_SHIP_CO_NAME = "RedShipCoName";
	private static final String P_RED_SHIP_COST = "RedShipCost";
	private static final String P_RED_SHIP_TRACKING_NO = "RedShipTrackingNo";
	private static final String P_RED_SHIP_COMTS = "RedShipComts";
	private static final String P_RED_SHIP_CARR_CD = "RedShipCarrCd";
	private static final String P_RED_SHIP_MTHD = "RedShipMthd";
	private static final String P_RED_CORP_ADDR1 = "RedCorpAddr1";
	private static final String P_RED_CORP_ADDR2 = "RedCorpAddr2";
	private static final String P_RED_CORP_ADDR3 = "RedCorpAddr3";
	private static final String P_RED_CORP_CITY = "RedCorpCity";
	private static final String P_RED_CORP_DESC = "RedCorpDesc";
	private static final String P_RED_CORP_FAX = "RedCorpFax";
	private static final String P_RED_CORP_NAME = "RedCorpName";
	private static final String P_RED_CORP_PHONE = "RedCorpPhone";
	private static final String P_RED_CORP_POSTBOX_NO = "RedCorpPostboxNo";
	private static final String P_RED_CORP_POSTAL_CD = "RedCorpPostalCd";
	private static final String P_RED_CORP_PURCHASE = "RedCorpPurchase";
	private static final String P_RED_CORP_STPR_CD = "RedCorpStprCd";
	private static final String P_RED_CORP_CNTRY_CD = "RedCorpCntrycd";
	private static final String P_RED_ITEM_SKU = "RedItemSku";
	private static final String P_RED_ITEM_MRCT_ID = "RedItemMrctId";
	private static final String P_RED_ITEM_TRACKING_NO = "RedItemTrackingNo";
	private static final String P_RED_ITEM_NAME = "RedItemName";
	private static final String P_RED_ITEM_DISCNT = "RedItemDiscnt";
	private static final String P_RED_ITEM_SHIP_COMTS = "RedItemShipComts";
	private static final String P_RED_ITEM_SHIP_MTHD = "RedItemShipMthd";
	private static final String P_RED_ITEM_TYPE = "RedItemType";
	private static final String P_RED_ITEM_CATEGORY = "RedItemCategory";
	private static final String P_RED_RECIP_ADDR1_ = "RedRecipAddr1_";
	private static final String P_RED_RECIP_ADDR2_ = "RedRecipAddr2_";
	private static final String P_RED_RECIP_ADDR3_ = "RedRecipAddr3_";
	private static final String P_RED_RECIP_CITY = "RedRecipCity";
	private static final String P_RED_RECIP_CNTRY_CD = "RedRecipCntryCd";
	private static final String P_RED_RECIP_EMAIL = "RedRecipEmail";
	private static final String P_RED_RECIP_FNAME = "RedRecipFname";
	private static final String P_RED_RECIP_LNAME = "RedRecipLname";
	private static final String P_RED_RECIP_MNAME = "RedRecipMname";
	private static final String P_RED_RECIP_PHONE = "RedRecipPhone";
	private static final String P_RED_RECIP_POSTAL_CD = "RedRecipPostalCd";
	private static final String P_RED_RECIP_SALUTATION = "RedRecipSalutation";
	private static final String P_RED_RECIP_STPR_CD = "RedRecipStprCd";
	private static final String P_RED_GIFT_CARD_MSG = "RedGiftCardMsg";
	private static final String P_RED_GIFT_CARD_TYPE = "RedGiftCardType";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("UTF-8");
        res.setContentType("text/html; charset=UTF-8");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        ExecFraudScreeningInput input = new ExecFraudScreeningInput();
        ExecFraudScreeningOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setExecMode(req.getParameter(P_EXEC_MODE));
		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setRedAmt(
				req.getParameter(P_RED_AMT) == null || req.getParameter(P_RED_AMT).length() == 0
					? null : new BigDecimal(req.getParameter(P_RED_AMT)));

		input.setRedCurrCd(req.getParameter(P_RED_CURR_CD));
		input.setRedAcctNum(req.getParameter(P_RED_ACCT_NUM));
		input.setRedCardExpDt(req.getParameter(P_RED_CARD_EXP_DT));
		input.setRedCustTypeCd(req.getParameter(P_RED_CUST_TYPE_CD));
		input.setRedCustId(req.getParameter(P_RED_CUST_ID));
		input.setRedCustFname(req.getParameter(P_RED_CUST_FNAME));
		input.setRedCustLname(req.getParameter(P_RED_CUST_LNAME));
		input.setRedCustAddr1(req.getParameter(P_RED_CUST_ADDR1));
		input.setRedCustAddr2(req.getParameter(P_RED_CUST_ADDR2));
		input.setRedCustAddr3(req.getParameter(P_RED_CUST_ADDR3));
		input.setRedCustCity(req.getParameter(P_RED_CUST_CITY));
		input.setRedCustPostalCd(req.getParameter(P_RED_CUST_POSTAL_CD));
		input.setRedCustCntryCd(req.getParameter(P_RED_CUST_CNTRY_CD));
		input.setRedCustHomePhone(req.getParameter(P_RED_CUST_HOME_PHONE));
		input.setRedCustEmail(req.getParameter(P_RED_CUST_EMAIL));
		input.setRedCustIpAddr(req.getParameter(P_RED_CUST_IP_ADDR));
		input.setRedEbtPrevcust(req.getParameter(P_RED_EBT_PREVCUST));
		input.setRedEbtTof(
				req.getParameter(P_RED_EBT_TOF) == null || req.getParameter(P_RED_EBT_TOF).length() == 0
					? null : Integer.valueOf(req.getParameter(P_RED_EBT_TOF)));

		input.setRedShipTypeCd(req.getParameter(P_RED_SHIP_TYPE_CD));
		input.setRedShipFname(req.getParameter(P_RED_SHIP_FNAME));
		input.setRedShipLname(req.getParameter(P_RED_SHIP_LNAME));
		input.setRedShipAddr1(req.getParameter(P_RED_SHIP_ADDR1));
		input.setRedShipAddr2(req.getParameter(P_RED_SHIP_ADDR2));
		input.setRedShipAddr3(req.getParameter(P_RED_SHIP_ADDR3));
		input.setRedShipCity(req.getParameter(P_RED_SHIP_CITY));
		input.setRedShipPostalCd(req.getParameter(P_RED_SHIP_POSTAL_CD));
		input.setRedEmpCompany(req.getParameter(P_RED_EMP_COMPANY));
		input.setRedEbtDeviceprint(req.getParameter(P_RED_EBT_DEVICEPRINT));
		input.setRedEbtUserData8(req.getParameter(P_RED_EBT_USER_DATA8));
		input.setRedEbtUserData9(req.getParameter(P_RED_EBT_USER_DATA9));
		input.setRedEbtUserData11(
				req.getParameter(P_RED_EBT_USER_DATA11) == null || req.getParameter(P_RED_EBT_USER_DATA11).length() == 0
					? null : Integer.valueOf(req.getParameter(P_RED_EBT_USER_DATA11)));

		input.setRedEbtUserData12(
				req.getParameter(P_RED_EBT_USER_DATA12) == null || req.getParameter(P_RED_EBT_USER_DATA12).length() == 0
					? null : Integer.valueOf(req.getParameter(P_RED_EBT_USER_DATA12)));

		input.setRedEbtUserData13(req.getParameter(P_RED_EBT_USER_DATA13));
		input.setRedEbtUserData15(req.getParameter(P_RED_EBT_USER_DATA15));
		input.setRedEbtUserData16(req.getParameter(P_RED_EBT_USER_DATA16));
		input.setRedEbtUserData17(
				req.getParameter(P_RED_EBT_USER_DATA17) == null || req.getParameter(P_RED_EBT_USER_DATA17).length() == 0
					? null : Integer.valueOf(req.getParameter(P_RED_EBT_USER_DATA17)));

		input.setRedEbtUserData18(
				req.getParameter(P_RED_EBT_USER_DATA18) == null || req.getParameter(P_RED_EBT_USER_DATA18).length() == 0
					? null : Integer.valueOf(req.getParameter(P_RED_EBT_USER_DATA18)));

		input.setRedEbtUserData19(req.getParameter(P_RED_EBT_USER_DATA19));
		input.setRedEbtUserData20(
				req.getParameter(P_RED_EBT_USER_DATA20) == null || req.getParameter(P_RED_EBT_USER_DATA20).length() == 0
				? null : Integer.valueOf(req.getParameter(P_RED_EBT_USER_DATA20)));
		input.setRedEbtUserData21(req.getParameter(P_RED_EBT_USER_DATA21));
		input.setRedEbtUserData22(req.getParameter(P_RED_EBT_USER_DATA22));
		input.setRedEbtUserData23(req.getParameter(P_RED_EBT_USER_DATA23));
		input.setRedEbtUserData24(req.getParameter(P_RED_EBT_USER_DATA24));
		input.setRedEbtUserData25(req.getParameter(P_RED_EBT_USER_DATA25));
		input.setRedCustMname(req.getParameter(P_RED_CUST_MNAME));
		input.setRedCustGender(req.getParameter(P_RED_CUST_GENDER));
		input.setRedCustWorkPhone(req.getParameter(P_RED_CUST_WORK_PHONE));
		input.setRedCustBirthDt(req.getParameter(P_RED_CUST_BIRTH_DT));
		input.setRedCustMobilePhone(req.getParameter(P_RED_CUST_MOBILE_PHONE));
		input.setRedCustDocId(req.getParameter(P_RED_CUST_DOC_ID));
		input.setRedCustDocType(req.getParameter(P_RED_CUST_DOC_TYPE));
		input.setRedCustStprCd(req.getParameter(P_RED_CUST_STPR_CD));
		input.setRedShipMname(req.getParameter(P_RED_SHIP_MNAME));
		input.setRedShipStprCd(req.getParameter(P_RED_SHIP_STPR_CD));
		input.setRedShipCntryCd(req.getParameter(P_RED_SHIP_CNTRY_CD));
		input.setRedShipEmail(req.getParameter(P_RED_SHIP_EMAIL));
		input.setRedShipHomePhone(req.getParameter(P_RED_SHIP_HOME_PHONE));
		input.setRedShipCoName(req.getParameter(P_RED_SHIP_CO_NAME));
		input.setRedShipCost(
				req.getParameter(P_RED_SHIP_COST) == null || req.getParameter(P_RED_SHIP_COST).length() == 0
				? null : new BigDecimal(req.getParameter(P_RED_SHIP_COST)));
		input.setRedShipTrackingNo(req.getParameter(P_RED_SHIP_TRACKING_NO));
		input.setRedShipComts(req.getParameter(P_RED_SHIP_COMTS));
		input.setRedShipCarrCd(req.getParameter(P_RED_SHIP_CARR_CD));
		input.setRedShipMthd(req.getParameter(P_RED_SHIP_MTHD));
		input.setRedCorpAddr1(req.getParameter(P_RED_CORP_ADDR1));
		input.setRedCorpAddr2(req.getParameter(P_RED_CORP_ADDR2));
		input.setRedCorpAddr3(req.getParameter(P_RED_CORP_ADDR3));
		input.setRedCorpCity(req.getParameter(P_RED_CORP_CITY));
		input.setRedCorpDesc(req.getParameter(P_RED_CORP_DESC));
		input.setRedCorpFax(req.getParameter(P_RED_CORP_FAX));
		input.setRedCorpName(req.getParameter(P_RED_CORP_NAME));
		input.setRedCorpPhone(req.getParameter(P_RED_CORP_PHONE));
		input.setRedCorpPostboxNo(req.getParameter(P_RED_CORP_POSTBOX_NO));
		input.setRedCorpPostalCd(req.getParameter(P_RED_CORP_POSTAL_CD));
		input.setRedCorpPurchase(req.getParameter(P_RED_CORP_PURCHASE));
		input.setRedCorpStprCd(req.getParameter(P_RED_CORP_STPR_CD));
		input.setRedCorpCntrycd(req.getParameter(P_RED_CORP_CNTRY_CD));
		input.setRedGiftCardMsg(req.getParameter(P_RED_GIFT_CARD_MSG));
		input.setRedGiftCardType(req.getParameter(P_RED_GIFT_CARD_TYPE));

		List itemList = new ArrayList();

		for(int i=1; req.getParameter(P_RED_ITEM_PROD_CD + i ) != null ;i++){

			RedItemHolder holder = new ExecFraudScreeningInput().new RedItemHolder();

			holder.setRedItemQty(
					req.getParameter(P_RED_ITEM_QTY + i) == null || req.getParameter(P_RED_ITEM_QTY + i).length() == 0
					? null : Long.valueOf(req.getParameter(P_RED_ITEM_QTY + i)));
			holder.setRedItemProdCd(req.getParameter(P_RED_ITEM_PROD_CD + i));
			holder.setRedItemManPartNo(req.getParameter(P_RED_ITEM_MAN_PART_NO + i));
			holder.setRedItemDesc(req.getParameter(P_RED_ITEM_DESC + i));
			holder.setRedEbtItemCst(
					req.getParameter(P_RED_EBT_ITEM_CST + i) == null || req.getParameter(P_RED_EBT_ITEM_CST + i).length() == 0
					? null : new BigDecimal(req.getParameter(P_RED_EBT_ITEM_CST + i)));
			holder.setRedItemGiftMsg(req.getParameter(P_RED_ITEM_GIFT_MSG + i));
			holder.setRedItemSku(req.getParameter(P_RED_ITEM_SKU + i));
			holder.setRedItemMrctId(req.getParameter(P_RED_ITEM_MRCT_ID + i));
			holder.setRedItemTrackingNo(req.getParameter(P_RED_ITEM_TRACKING_NO + i));
			holder.setRedItemName(req.getParameter(P_RED_ITEM_NAME + i));
			holder.setRedItemDiscnt(
							req.getParameter(P_RED_ITEM_DISCNT + i) == null || req.getParameter(P_RED_ITEM_DISCNT + i).length() == 0
				    ? null : new BigDecimal(req.getParameter(P_RED_ITEM_DISCNT + i)));
			holder.setRedItemShipComts(req.getParameter(P_RED_ITEM_SHIP_COMTS + i));
			holder.setRedItemShipMthd(req.getParameter(P_RED_ITEM_SHIP_MTHD + i));
			holder.setRedItemType(req.getParameter(P_RED_ITEM_TYPE + i));
			holder.setRedItemCategory(req.getParameter(P_RED_ITEM_CATEGORY + i));
			holder.setRedRecipAddr1(req.getParameter(P_RED_RECIP_ADDR1_ + i));
			holder.setRedRecipAddr2(req.getParameter(P_RED_RECIP_ADDR2_ + i));
			holder.setRedRecipAddr3(req.getParameter(P_RED_RECIP_ADDR3_ + i));
			holder.setRedRecipCity(req.getParameter(P_RED_RECIP_CITY + i));
			holder.setRedRecipCntryCd(req.getParameter(P_RED_RECIP_CNTRY_CD + i));
			holder.setRedRecipEmail(req.getParameter(P_RED_RECIP_EMAIL + i));
			holder.setRedRecipFname(req.getParameter(P_RED_RECIP_FNAME + i));
			holder.setRedRecipLname(req.getParameter(P_RED_RECIP_LNAME + i));
			holder.setRedRecipMname(req.getParameter(P_RED_RECIP_MNAME + i));
			holder.setRedRecipPhone(req.getParameter(P_RED_RECIP_PHONE + i));
			holder.setRedRecipPostalCd(req.getParameter(P_RED_RECIP_POSTAL_CD + i));
			holder.setRedRecipSalutation(req.getParameter(P_RED_RECIP_SALUTATION + i));
			holder.setRedRecipStprCd(req.getParameter(P_RED_RECIP_STPR_CD + i));

			itemList.add(holder);

		}
		input.setRedItemList(itemList);
		input.setTelegramType(req.getParameter(P_TELEGRAM_TYPE));
		input.setToken(req.getParameter(P_TOKEN));
		input.setMemberId(req.getParameter(P_MEMBER_ID));
		input.setSiteId(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setSeqMode(req.getParameter(P_SEQ_MODE));
		input.setCardSeq(req.getParameter(P_CARD_SEQ));
		input.setRedOrdId(req.getParameter(P_RED_ORD_ID));

		print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doExecFraudScreening(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
		print(out, "RedReqId: {0}", output.getRedReqId());
		print(out, "RedOrdId: {0}", output.getRedOrdId());
		print(out, "RedStatCd: {0}", output.getRedStatCd());
		print(out, "RedFraudStatCd: {0}", output.getRedFraudStatCd());
		print(out, "RedFraudRspCd: {0}", output.getRedFraudRspCd());
		print(out, "RedFraudRspMsg: {0}", output.getRedFraudRspMsg());
		print(out, "RedFraudRecId: {0}", output.getRedFraudRecId());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
