package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.ExecTranAndFraudScreeningInput;
import com.gmo_pg.g_pay.client.input.FraudScreeningInput;
import com.gmo_pg.g_pay.client.input.FraudScreeningInput.RedItemHolder;
import com.gmo_pg.g_pay.client.output.ExecTranAndFraudScreeningOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;

/**
 * 不正防止決済実行＆不正防止呼出サーブレットサンプルクラス
 */
public class CallExecTranAndFraudScreeningServlet extends HttpServlet {

	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_METHOD = "Method";
	private static final String P_PAY_TIMES = "PayTimes";
	private static final String P_CARD_NO = "CardNo";
	private static final String P_EXPIRE = "Expire";
	private static final String P_SECURITY_CODE = "SecurityCode";
	private static final String P_TOKEN = "Token";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_CLIENT_FIELD_FLAG = "ClientFieldFlag";
	private static final String P_RED_ORD_DTM = "RedOrdDtm";
	private static final String P_RED_AMT = "RedAmt";
	private static final String P_RED_REQ_TYPE_CD = "RedReqTypeCd";
	private static final String P_RED_MOP_TYPE_CD = "RedMopTypeCd";
	private static final String P_RED_ACCT_NUM = "RedAcctNum";
	private static final String P_RED_CARD_EXP_DT = "RedCardExpDt";
	private static final String P_RED_CURR_CD = "RedCurrCd";
	private static final String P_RED_ORD_ID = "RedOrdId";
	private static final String P_RED_ACT_CD = "RedActCd";
	private static final String P_RED_DIV_NUM = "RedDivNum";
	private static final String P_RED_S_KEY_ID = "RedSKeyId";
	private static final String P_RED_EBT_SERVICE = "RedEbtService";
	private static final String P_RED_EBT_NAME = "RedEbtName";
	private static final String P_RED_USER_ID = "RedUserId";
	private static final String P_RED_CUST_TYPE_CD = "RedCustTypeCd";
	private static final String P_RED_CUST_ID = "RedCustId";
	private static final String P_RED_CUST_FNAME = "RedCustFname";
	private static final String P_RED_CUST_LNAME = "RedCustLname";
	private static final String P_RED_CUST_BIRTH_DT = "RedCustBirthDt";
	private static final String P_RED_CUST_EMAIL = "RedCustEmail";
	private static final String P_RED_CUST_APT = "RedCustApt";
	private static final String P_RED_CUST_ADDR1 = "RedCustAddr1";
	private static final String P_RED_CUST_ADDR2 = "RedCustAddr2";
	private static final String P_RED_CUST_CITY = "RedCustCity";
	private static final String P_RED_CUST_CNTRY_CD = "RedCustCntryCd";
	private static final String P_RED_CUST_POSTAL_CD = "RedCustPostalCd";
	private static final String P_RED_CUST_IP_ADDR = "RedCustIpAddr";
	private static final String P_RED_EBT_PREVCUST = "RedEbtPrevcust";
	private static final String P_RED_CUST_HOME_PHONE = "RedCustHomePhone";
	private static final String P_RED_CUST_WORK_PHONE = "RedCustWorkPhone";
	private static final String P_RED_CUST_MOBILE_PHONE = "RedCustMobilePhone";
	private static final String P_RED_EBT_TOF = "RedEbtTof";
	private static final String P_RED_SHIP_TYPE_CD = "RedShipTypeCd";
	private static final String P_RED_SHIP_FNAME = "RedShipFname";
	private static final String P_RED_SHIP_LNAME = "RedShipLname";
	private static final String P_RED_SHIP_EMAIL = "RedShipEmail";
	private static final String P_RED_SHIP_APT = "RedShipApt";
	private static final String P_RED_SHIP_ADDR1 = "RedShipAddr1";
	private static final String P_RED_SHIP_ADDR2 = "RedShipAddr2";
	private static final String P_RED_SHIP_CITY = "RedShipCity";
	private static final String P_RED_SHIP_CNTRY_CD = "RedShipCntryCd";
	private static final String P_RED_SHIP_POSTAL_CD = "RedShipPostalCd";
	private static final String P_RED_SHIP_HOME_PHONE = "RedShipHomePhone";
	private static final String P_RED_SHIP_FAX_PHONE = "RedShipFaxPhone";
	private static final String P_RED_SHIP_MTHD_CD = "RedShipMthdCd";
	private static final String P_RED_EBT_USER_DATA1 = "RedEbtUserData1";
	private static final String P_RED_EBT_USER_DATA2 = "RedEbtUserData2";
	private static final String P_RED_EBT_USER_DATA3 = "RedEbtUserData3";
	private static final String P_RED_EBT_USER_DATA4 = "RedEbtUserData4";
	private static final String P_RED_EBT_USER_DATA5 = "RedEbtUserData5";
	private static final String P_RED_EBT_USER_DATA6 = "RedEbtUserData6";
	private static final String P_RED_EBT_USER_DATA7 = "RedEbtUserData7";
	private static final String P_RED_EBT_USER_DATA8 = "RedEbtUserData8";
	private static final String P_RED_EBT_USER_DATA9 = "RedEbtUserData9";
	private static final String P_RED_EBT_USER_DATA10 = "RedEbtUserData10";
	private static final String P_RED_EBT_USER_DATA11 = "RedEbtUserData11";
	private static final String P_RED_EBT_USER_DATA12 = "RedEbtUserData12";
	private static final String P_RED_EBT_USER_DATA13 = "RedEbtUserData13";
	private static final String P_RED_EBT_USER_DATA14 = "RedEbtUserData14";
	private static final String P_RED_EBT_USER_DATA15 = "RedEbtUserData15";
	private static final String P_RED_EBT_USER_DATA16 = "RedEbtUserData16";
	private static final String P_RED_EBT_USER_DATA17 = "RedEbtUserData17";
	private static final String P_RED_EBT_USER_DATA18 = "RedEbtUserData18";
	private static final String P_RED_EBT_USER_DATA19 = "RedEbtUserData19";
	private static final String P_RED_EBT_USER_DATA20 = "RedEbtUserData20";
	private static final String P_RED_EBT_USER_DATA21 = "RedEbtUserData21";
	private static final String P_RED_EBT_USER_DATA22 = "RedEbtUserData22";
	private static final String P_RED_EBT_USER_DATA23 = "RedEbtUserData23";
	private static final String P_RED_EBT_USER_DATA24 = "RedEbtUserData24";
	private static final String P_RED_EBT_USER_DATA25 = "RedEbtUserData25";
	private static final String P_RED_EBWEBSITE = "RedEbwebsite";
	private static final String P_RED_ITEM_PROD_CD = "RedItemProdCd";
	private static final String P_RED_ITEM_COMM_CD = "RedItemCommCd";
	private static final String P_RED_ITEM_DESC = "RedItemDesc";
	private static final String P_RED_ITEM_QTY = "RedItemQty";
	private static final String P_RED_EBT_PRODUNITPRICE = "RedEbtProdunitprice";
	private static final String P_RED_ITEM_AMT = "RedItemAmt";
	private static final String P_RED_ITEM_SHIP_NO = "RedItemShipNo";
	private static final String P_RED_ITEM_GIFT_MSG = "RedItemGiftMsg";
	private static final String P_RED_ITEM_MAN_PART_NO = "RedItemManPartNo";
	private static final String P_RED_ITEM_SHIP_COMMENTS = "RedItemShipComments";
	private static final String P_RED_EBT_DEVICEPRINT = "RedEbtDeviceprint";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        ExecTranAndFraudScreeningInput input = new ExecTranAndFraudScreeningInput();
        ExecTranAndFraudScreeningOutput output = null;

        // パラメータの設定
		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setMethod(req.getParameter(P_METHOD));
		input.setPayTimes(req.getParameter(P_PAY_TIMES));
		input.setCardNo(req.getParameter(P_CARD_NO));
		input.setExpire(req.getParameter(P_EXPIRE));
		input.setSecurityCode(req.getParameter(P_SECURITY_CODE));
		input.setToken(req.getParameter(P_TOKEN));
		input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
		input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setClientFieldFlag(req.getParameter(P_CLIENT_FIELD_FLAG));
		input.setRedOrdDtm(req.getParameter(P_RED_ORD_DTM));
		input.setRedAmt(
				req.getParameter(P_RED_AMT) == null || req.getParameter(P_RED_AMT).length() == 0
					? null : Long.valueOf(req.getParameter(P_RED_AMT)));

		input.setRedReqTypeCd(req.getParameter(P_RED_REQ_TYPE_CD));
		input.setRedMopTypeCd(req.getParameter(P_RED_MOP_TYPE_CD));
		input.setRedAcctNum(req.getParameter(P_RED_ACCT_NUM));
		input.setRedCardExpDt(req.getParameter(P_RED_CARD_EXP_DT));
		input.setRedCurrCd(req.getParameter(P_RED_CURR_CD));
		input.setRedOrdId(req.getParameter(P_RED_ORD_ID));
		input.setRedActCd(req.getParameter(P_RED_ACT_CD));
		input.setRedDivNum(req.getParameter(P_RED_DIV_NUM));
		input.setRedSKeyId(req.getParameter(P_RED_S_KEY_ID));
		input.setRedEbtService(req.getParameter(P_RED_EBT_SERVICE));
		input.setRedEbtName(req.getParameter(P_RED_EBT_NAME));
		input.setRedUserId(req.getParameter(P_RED_USER_ID));
		input.setRedCustTypeCd(req.getParameter(P_RED_CUST_TYPE_CD));
		input.setRedCustId(req.getParameter(P_RED_CUST_ID));
		input.setRedCustFname(req.getParameter(P_RED_CUST_FNAME));
		input.setRedCustLname(req.getParameter(P_RED_CUST_LNAME));
		input.setRedCustBirthDt(req.getParameter(P_RED_CUST_BIRTH_DT));
		input.setRedCustEmail(req.getParameter(P_RED_CUST_EMAIL));
		input.setRedCustApt(req.getParameter(P_RED_CUST_APT));
		input.setRedCustAddr1(req.getParameter(P_RED_CUST_ADDR1));
		input.setRedCustAddr2(req.getParameter(P_RED_CUST_ADDR2));
		input.setRedCustCity(req.getParameter(P_RED_CUST_CITY));
		input.setRedCustCntryCd(req.getParameter(P_RED_CUST_CNTRY_CD));
		input.setRedCustPostalCd(req.getParameter(P_RED_CUST_POSTAL_CD));
		input.setRedCustIpAddr(req.getParameter(P_RED_CUST_IP_ADDR));
		input.setRedEbtPrevcust(req.getParameter(P_RED_EBT_PREVCUST));
		input.setRedCustHomePhone(req.getParameter(P_RED_CUST_HOME_PHONE));
		input.setRedCustWorkPhone(req.getParameter(P_RED_CUST_WORK_PHONE));
		input.setRedCustMobilePhone(req.getParameter(P_RED_CUST_MOBILE_PHONE));
		input.setRedEbtTof(
				req.getParameter(P_RED_EBT_TOF) == null || req.getParameter(P_RED_EBT_TOF).length() == 0
					? null : Integer.valueOf(req.getParameter(P_RED_EBT_TOF)));

		input.setRedShipTypeCd(req.getParameter(P_RED_SHIP_TYPE_CD));
		input.setRedShipFname(req.getParameter(P_RED_SHIP_FNAME));
		input.setRedShipLname(req.getParameter(P_RED_SHIP_LNAME));
		input.setRedShipEmail(req.getParameter(P_RED_SHIP_EMAIL));
		input.setRedShipApt(req.getParameter(P_RED_SHIP_APT));
		input.setRedShipAddr1(req.getParameter(P_RED_SHIP_ADDR1));
		input.setRedShipAddr2(req.getParameter(P_RED_SHIP_ADDR2));
		input.setRedShipCity(req.getParameter(P_RED_SHIP_CITY));
		input.setRedShipCntryCd(req.getParameter(P_RED_SHIP_CNTRY_CD));
		input.setRedShipPostalCd(req.getParameter(P_RED_SHIP_POSTAL_CD));
		input.setRedShipHomePhone(req.getParameter(P_RED_SHIP_HOME_PHONE));
		input.setRedShipFaxPhone(req.getParameter(P_RED_SHIP_FAX_PHONE));
		input.setRedShipMthdCd(req.getParameter(P_RED_SHIP_MTHD_CD));
		input.setRedEbtUserData1(req.getParameter(P_RED_EBT_USER_DATA1));
		input.setRedEbtUserData2(req.getParameter(P_RED_EBT_USER_DATA2));
		input.setRedEbtUserData3(req.getParameter(P_RED_EBT_USER_DATA3));
		input.setRedEbtUserData4(req.getParameter(P_RED_EBT_USER_DATA4));
		input.setRedEbtUserData5(req.getParameter(P_RED_EBT_USER_DATA5));
		input.setRedEbtUserData6(req.getParameter(P_RED_EBT_USER_DATA6));
		input.setRedEbtUserData7(req.getParameter(P_RED_EBT_USER_DATA7));
		input.setRedEbtUserData8(req.getParameter(P_RED_EBT_USER_DATA8));
		input.setRedEbtUserData9(req.getParameter(P_RED_EBT_USER_DATA9));
		input.setRedEbtUserData10(req.getParameter(P_RED_EBT_USER_DATA10));
		input.setRedEbtUserData11(req.getParameter(P_RED_EBT_USER_DATA11));
		input.setRedEbtUserData12(req.getParameter(P_RED_EBT_USER_DATA12));
		input.setRedEbtUserData13(req.getParameter(P_RED_EBT_USER_DATA13));
		input.setRedEbtUserData14(req.getParameter(P_RED_EBT_USER_DATA14));
		input.setRedEbtUserData15(req.getParameter(P_RED_EBT_USER_DATA15));
		input.setRedEbtUserData16(req.getParameter(P_RED_EBT_USER_DATA16));
		input.setRedEbtUserData17(req.getParameter(P_RED_EBT_USER_DATA17));
		input.setRedEbtUserData18(req.getParameter(P_RED_EBT_USER_DATA18));
		input.setRedEbtUserData19(req.getParameter(P_RED_EBT_USER_DATA19));
		input.setRedEbtUserData20(req.getParameter(P_RED_EBT_USER_DATA20));
		input.setRedEbtUserData21(req.getParameter(P_RED_EBT_USER_DATA21));
		input.setRedEbtUserData22(req.getParameter(P_RED_EBT_USER_DATA22));
		input.setRedEbtUserData23(req.getParameter(P_RED_EBT_USER_DATA23));
		input.setRedEbtUserData24(req.getParameter(P_RED_EBT_USER_DATA24));
		input.setRedEbtUserData25(req.getParameter(P_RED_EBT_USER_DATA25));
		input.setRedEbwebsite(req.getParameter(P_RED_EBWEBSITE));

		List itemList = new ArrayList();

		for(int i=1; req.getParameter(P_RED_ITEM_PROD_CD + i ) != null ;i++){

			RedItemHolder holder = new FraudScreeningInput().new RedItemHolder();

			holder.setRedItemProdCd(req.getParameter(P_RED_ITEM_PROD_CD + i));
			holder.setRedItemCommCd(req.getParameter(P_RED_ITEM_COMM_CD + i));
			holder.setRedItemDesc(req.getParameter(P_RED_ITEM_DESC + i));
			holder.setRedItemQty(
					req.getParameter(P_RED_ITEM_QTY + i) == null || req.getParameter(P_RED_ITEM_QTY + i).length() == 0
					? null : Long.valueOf(req.getParameter(P_RED_ITEM_QTY + i)));
			holder.setRedEbtProdunitprice(
					req.getParameter(P_RED_EBT_PRODUNITPRICE + i) == null || req.getParameter(P_RED_EBT_PRODUNITPRICE + i).length() == 0
					? null : Long.valueOf(req.getParameter(P_RED_EBT_PRODUNITPRICE + i)));
			holder.setRedItemAmt(
					req.getParameter(P_RED_ITEM_AMT + i) == null || req.getParameter(P_RED_ITEM_AMT + i).length() == 0
					? null : Long.valueOf(req.getParameter(P_RED_ITEM_AMT + i)));
			holder.setRedItemShipNo(req.getParameter(P_RED_ITEM_SHIP_NO + i));
			holder.setRedItemGiftMsg(req.getParameter(P_RED_ITEM_GIFT_MSG + i));
			holder.setRedItemManPartNo(req.getParameter(P_RED_ITEM_MAN_PART_NO + i));
			holder.setRedItemShipComments(req.getParameter(P_RED_ITEM_SHIP_COMMENTS + i));

			itemList.add(holder);

		}
		input.setRedItemList(itemList);

		input.setRedEbtDeviceprint(req.getParameter(P_RED_EBT_DEVICEPRINT));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doExecTranAndFraudScreening(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "ACS: {0}", output.getACS());
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "Forward: {0}", output.getForward());
			print(out, "Method: {0}", output.getMethod());
			print(out, "PayTimes: {0}", output.getPayTimes());
			print(out, "Approve: {0}", output.getApprove());
			print(out, "TranID: {0}", output.getTranID());
			print(out, "TranDate: {0}", output.getTranDate());
			print(out, "CheckString: {0}", output.getCheckString());
			print(out, "ClientField1: {0}", output.getClientField1());
			print(out, "ClientField2: {0}", output.getClientField2());
			print(out, "ClientField3: {0}", output.getClientField3());
			print(out, "RedReqId: {0}", output.getRedReqId());
			print(out, "RedOrdId: {0}", output.getRedOrdId());
			print(out, "RedStatCd: {0}", output.getRedStatCd());
			print(out, "RedFraudStatCd: {0}", output.getRedFraudStatCd());
			print(out, "RedFraudRspCd: {0}", output.getRedFraudRspCd());
			print(out, "RedFraudRecId: {0}", output.getRedFraudRecId());
		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
