package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.ExecTranLinepayInput;
import com.gmo_pg.g_pay.client.output.ExecTranLinepayOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * LINE Pay決済実行呼出サーブレットサンプルクラス
 */
public class CallExecTranLinepayServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_MEMBER_NAME = "MemberName";
	private static final String P_CREATE_MEMBER = "CreateMember";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_CLIENT_FIELD_FLAG = "ClientFieldFlag";
	private static final String P_RET_URL = "RetURL";
	private static final String P_ERROR_RCV_URL = "ErrorRcvURL";
	private static final String P_PRODUCT_IMAGE_URL = "ProductImageUrl";
	private static final String P_MID = "Mid";
	private static final String P_DELIVERY_PLACE_PHONE = "DeliveryPlacePhone";
	private static final String P_LANG_CODE = "LangCode";
	private static final String P_PRODUCT_NAME = "ProductName";
	private static final String P_PACKAGE_NAME = "PackageName";
	private static final String P_USER_INFO = "UserInfo";
	private static final String P_RETURN_URL = "ReturnUrl";
	private static final String P_BRANCH_NAME = "BranchName";
	private static final String P_BRANCH_ID = "BranchID";
	private static final String P_PAYMENT_TYPE = "PaymentType";
	private static final String P_SETTLEMENT_REG_KEY = "SettlementRegKey";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        ExecTranLinepayInput input = new ExecTranLinepayInput();
        ExecTranLinepayOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setMemberID(req.getParameter(P_MEMBER_ID));
		input.setMemberName(req.getParameter(P_MEMBER_NAME));
		input.setCreateMember(req.getParameter(P_CREATE_MEMBER));
		input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
		input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setClientFieldFlag(req.getParameter(P_CLIENT_FIELD_FLAG));
		input.setRetURL(req.getParameter(P_RET_URL));
		input.setErrorRcvURL(req.getParameter(P_ERROR_RCV_URL));
		input.setProductImageUrl(req.getParameter(P_PRODUCT_IMAGE_URL));
		input.setMid(req.getParameter(P_MID));
		input.setDeliveryPlacePhone(req.getParameter(P_DELIVERY_PLACE_PHONE));
		input.setLangCode(req.getParameter(P_LANG_CODE));
		input.setProductName(req.getParameter(P_PRODUCT_NAME));
		input.setPackageName(req.getParameter(P_PACKAGE_NAME));
		input.setUserInfo(req.getParameter(P_USER_INFO));
		input.setReturnUrl(req.getParameter(P_RETURN_URL));
		input.setBranchName(req.getParameter(P_BRANCH_NAME));
		input.setBranchID(req.getParameter(P_BRANCH_ID));
		input.setPaymentType(req.getParameter(P_PAYMENT_TYPE));
		input.setSettlementRegKey(req.getParameter(P_SETTLEMENT_REG_KEY));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doExecTranLinepay(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "Start: {0}", output.getStart());
			print(out, "AccessID: {0}", output.getAccessID());
			print(out, "Token: {0}", output.getToken());
			print(out, "StartURL: {0}", output.getStartURL());
			print(out, "Status: {0}", output.getStatus());
			print(out, "PayMethod: {0}", output.getPayMethod());
			print(out, "CheckString: {0}", output.getCheckString());
			print(out, "ClientField1: {0}", output.getClientField1());
			print(out, "ClientField2: {0}", output.getClientField2());
			print(out, "ClientField3: {0}", output.getClientField3());
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "TranDate: {0}", output.getTranDate());
			print(out, "TranID: {0}", output.getTranID());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
