package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.ExecTranPayEasyInput;
import com.gmo_pg.g_pay.client.output.ErrHolder;
import com.gmo_pg.g_pay.client.output.ExecTranPayEasyOutput;

/**
 * PayEasy決済実行呼出サーブレットサンプルクラス
 */
public class CallExecTranPayEasyServlet extends HttpServlet {

	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_MAILADDRESS = "MailAddress";
	private static final String P_SHOPMAILADDRESS = "ShopMailAdress";
	private static final String P_PAYMENTTERMDAY = "PaymentTermDay";
	private static final String P_PAYMENT_EXPIRY_DATE_TIME = "PaymentExpiryDateTime";
	public static final String P_CUSTOMERNAME = "CustomerName";
	public static final String P_CUSTOMERKANA = "CustomerKana";
	public static final String P_TELNO = "TelNo";
	/** フリースペース1 */
	public static final String P_REGISTERDISP1 = "RegisterDisp1";
	/** フリースペース2 */
	public static final String P_REGISTERDISP2 = "RegisterDisp2";
	/** フリースペース3 */
	public static final String P_REGISTERDISP3 = "RegisterDisp3";
	/** フリースペース4 */
	public static final String P_REGISTERDISP4 = "RegisterDisp4";
	/** フリースペース5 */
	public static final String P_REGISTERDISP5 = "RegisterDisp5";
	/** フリースペース6 */
	public static final String P_REGISTERDISP6 = "RegisterDisp6";
	/** フリースペース7 */
	public static final String P_REGISTERDISP7 = "RegisterDisp7";
	/** フリースペース8 */
	public static final String P_REGISTERDISP8 = "RegisterDisp8";
	/** お客様へのご案内1 */
	public static final String P_RECEIPTSDISP1 = "ReceiptsDisp1";
	/** お客様へのご案内2 */
	public static final String P_RECEIPTSDISP2 = "ReceiptsDisp2";
	/** お客様へのご案内3 */
	public static final String P_RECEIPTSDISP3 = "ReceiptsDisp3";
	/** お客様へのご案内4 */
	public static final String P_RECEIPTSDISP4 = "ReceiptsDisp4";
	/** お客様へのご案内5 */
	public static final String P_RECEIPTSDISP5 = "ReceiptsDisp5";
	/** お客様へのご案内6 */
	public static final String P_RECEIPTSDISP6 = "ReceiptsDisp6";
	/** お客様へのご案内7 */
	public static final String P_RECEIPTSDISP7 = "ReceiptsDisp7";
	/** お客様へのご案内8 */
	public static final String P_RECEIPTSDISP8 = "ReceiptsDisp8";
	/** お客様へのご案内9 */
	public static final String P_RECEIPTSDISP9 = "ReceiptsDisp9";
	/** お客様へのご案内10 */
	public static final String P_RECEIPTSDISP10 = "ReceiptsDisp10";
	/** お問合せ先 */
	public static final String P_RECEIPTSDISP11 = "ReceiptsDisp11";
	/** お問合せ先電話番号 */
	public static final String P_RECEIPTSDISP12 = "ReceiptsDisp12";
	/** お問合せ先受付時間 */
	public static final String P_RECEIPTSDISP13 = "ReceiptsDisp13";


	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_CLIENT_FIELD_FLAG = "ClientFieldFlag";

	private static final String P_PAYMENT_TYPE = "PaymentType";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
	    	throws ServletException, IOException {
		doPost(req, res);
	}

    public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        ExecTranPayEasyInput input = new ExecTranPayEasyInput();
        ExecTranPayEasyOutput output = null;

        // パラメータの設定
        input.setAccessId(req.getParameter(P_ACCESS_ID));
        input.setAccessPass(req.getParameter(P_ACCESS_PASS));
        input.setOrderId(req.getParameter(P_ORDER_ID));

        input.setCustomerName(req.getParameter(P_CUSTOMERNAME));
        input.setCustomerKana(req.getParameter(P_CUSTOMERKANA));
        input.setTelNo(req.getParameter(P_TELNO));

		if (req.getParameter(P_PAYMENT_EXPIRY_DATE_TIME) == null) {
			input.setPaymentExpiryDateTime(null);
			input.setPaymentTermDay(req.getParameter(P_PAYMENTTERMDAY) == null ? null
							: Integer.valueOf(req.getParameter(P_PAYMENTTERMDAY)));
		} else {
			input.setPaymentExpiryDateTime(req.getParameter(P_PAYMENT_EXPIRY_DATE_TIME));
			input.setPaymentTermDay(null);
		}

        input.setMailAddress(req.getParameter(P_MAILADDRESS));
        input.setShopMailAdress(req.getParameter(P_SHOPMAILADDRESS));

        input.setRegisterDisp1(req.getParameter(P_REGISTERDISP1));
        input.setRegisterDisp2(req.getParameter(P_REGISTERDISP2));
        input.setRegisterDisp3(req.getParameter(P_REGISTERDISP3));
        input.setRegisterDisp4(req.getParameter(P_REGISTERDISP4));
        input.setRegisterDisp5(req.getParameter(P_REGISTERDISP5));
        input.setRegisterDisp6(req.getParameter(P_REGISTERDISP6));
        input.setRegisterDisp7(req.getParameter(P_REGISTERDISP7));
        input.setRegisterDisp8(req.getParameter(P_REGISTERDISP8));

        input.setReceiptsDisp1(req.getParameter(P_RECEIPTSDISP1));
        input.setReceiptsDisp2(req.getParameter(P_RECEIPTSDISP2));
        input.setReceiptsDisp3(req.getParameter(P_RECEIPTSDISP3));
        input.setReceiptsDisp4(req.getParameter(P_RECEIPTSDISP4));
        input.setReceiptsDisp5(req.getParameter(P_RECEIPTSDISP5));
        input.setReceiptsDisp6(req.getParameter(P_RECEIPTSDISP6));
        input.setReceiptsDisp7(req.getParameter(P_RECEIPTSDISP7));
        input.setReceiptsDisp8(req.getParameter(P_RECEIPTSDISP8));
        input.setReceiptsDisp9(req.getParameter(P_RECEIPTSDISP9));
        input.setReceiptsDisp10(req.getParameter(P_RECEIPTSDISP10));

        input.setReceiptsDisp11(req.getParameter(P_RECEIPTSDISP11));
        input.setReceiptsDisp12(req.getParameter(P_RECEIPTSDISP12));
        input.setReceiptsDisp13(req.getParameter(P_RECEIPTSDISP13));

        input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
        input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setClientFieldFlag(req.getParameter(P_CLIENT_FIELD_FLAG));
		input.setPaymentType(req.getParameter(P_PAYMENT_TYPE));
       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doExecTranPayEasy(input);
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
        if (output.isErrorOccurred()) {
        	List list = output.getErrList();
    		print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
        		print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
        						new Object[]{eh.getErrCode(), eh.getErrInfo()}));

        	}
        } else {
    		print(out, "OUTPUT:");
        	print(out, "CustID: {0}", output.getCustId());
        	print(out, "BkCode: {0}",	output.getBkCode());
        	print(out, "ConfNo: {0}",	output.getConfNo());
        	print(out, "EncryptReceiptNo: {0}",	output.getEncryptReceiptNo());
        	print(out, "PaymentTerm: {0}", output.getPaymentTerm());
        	print(out, "TranDate: {0}", output.getTranDate());
        	print(out, "CheckString: {0}", output.getCheckString());
        	print(out, "ClientField1: {0}", output.getClientField1());
        	print(out, "ClientField2: {0}", output.getClientField2());
        	print(out, "ClientField3: {0}", output.getClientField3());
        	print(out, "PaymentURL: {0}", output.getPaymentURL());

        }
        out.flush();
    }

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
