package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.Method;
import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.ExecTranInput;
import com.gmo_pg.g_pay.client.output.ErrHolder;
import com.gmo_pg.g_pay.client.output.ExecTranOutput;

/**
 * 決済実行呼出サーブレットサンプルクラス
 */
public class CallExecTranServlet extends HttpServlet {

	private static final String H_ACCEPT = "accept";
	private static final String H_USER_AGENT = "user-agent";

	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_CARD_NO = "CardNo";
	private static final String P_TOKEN = "Token";
	private static final String P_EXPIRE = "Expire";
	private static final String P_DEVICE_CATEGORY = "DeviceCategory";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_CLIENT_FIELD_FLAG = "ClientFieldFlag";
	private static final String P_DISPLAY_INFO = "DisplayInfo";
	private static final String P_TOKEN_TYPE = "TokenType";
	private static final String P_RET_URL = "RetUrl";
	private static final String P_APP_MODE = "AppMode";
	private static final String P_TDS2_CHALLENGE_IND_TYPE = "Tds2ChallengeIndType";
	private static final String P_CALLBACK_TYPE = "CallbackType";
	private static final String P_TDS2_CH_ACC_CHANGE = "Tds2ChAccChange";
	private static final String P_TDS2_CH_ACC_DATE = "Tds2ChAccDate";
	private static final String P_TDS2_CH_ACC_PW_CHANGE = "Tds2ChAccPwChange";
	private static final String P_TDS2_NB_PURCHASE_ACCOUNT = "Tds2NbPurchaseAccount";
	private static final String P_TDS2_PAYMENT_ACC_AGE = "Tds2PaymentAccAge";
	private static final String P_TDS2_PROVISION_ATTEMPTS_DAY = "Tds2ProvisionAttemptsDay";
	private static final String P_TDS2_SHIP_ADDRESS_USAGE = "Tds2ShipAddressUsage";
	private static final String P_TDS2_SHIP_NAME_IND = "Tds2ShipNameInd";
	private static final String P_TDS2_SUSPICIOUS_ACC_ACTIVITY = "Tds2SuspiciousAccActivity";
	private static final String P_TDS2_TXN_ACTIVITY_DAY = "Tds2TxnActivityDay";
	private static final String P_TDS2_TXN_ACTIVITY_YEAR = "Tds2TxnActivityYear";
	private static final String P_TDS2_THREE_D_S_REQ_AUTH_DATA = "Tds2ThreeDSReqAuthData";
	private static final String P_TDS2_THREE_D_S_REQ_AUTH_METHOD = "Tds2ThreeDSReqAuthMethod";
	private static final String P_TDS2_THREE_D_S_REQ_AUTH_TIMESTAMP = "Tds2ThreeDSReqAuthTimestamp";
	private static final String P_TDS2_ADDR_MATCH = "Tds2AddrMatch";
	private static final String P_TDS2_BILL_ADDR_CITY = "Tds2BillAddrCity";
	private static final String P_TDS2_BILL_ADDR_COUNTRY = "Tds2BillAddrCountry";
	private static final String P_TDS2_BILL_ADDR_LINE1 = "Tds2BillAddrLine1";
	private static final String P_TDS2_BILL_ADDR_LINE2 = "Tds2BillAddrLine2";
	private static final String P_TDS2_BILL_ADDR_LINE3 = "Tds2BillAddrLine3";
	private static final String P_TDS2_BILL_ADDR_POST_CODE = "Tds2BillAddrPostCode";
	private static final String P_TDS2_BILL_ADDR_STATE = "Tds2BillAddrState";
	private static final String P_TDS2_EMAIL = "Tds2Email";
	private static final String P_TDS2_HOME_PHONE_C_C = "Tds2HomePhoneCC";
	private static final String P_TDS2_HOME_PHONE_SUBSCRIBER = "Tds2HomePhoneSubscriber";
	private static final String P_TDS2_MOBILE_PHONE_C_C = "Tds2MobilePhoneCC";
	private static final String P_TDS2_MOBILE_PHONE_SUBSCRIBER = "Tds2MobilePhoneSubscriber";
	private static final String P_TDS2_WORK_PHONE_C_C = "Tds2WorkPhoneCC";
	private static final String P_TDS2_WORK_PHONE_SUBSCRIBER = "Tds2WorkPhoneSubscriber";
	private static final String P_TDS2_SHIP_ADDR_CITY = "Tds2ShipAddrCity";
	private static final String P_TDS2_SHIP_ADDR_COUNTRY = "Tds2ShipAddrCountry";
	private static final String P_TDS2_SHIP_ADDR_LINE1 = "Tds2ShipAddrLine1";
	private static final String P_TDS2_SHIP_ADDR_LINE2 = "Tds2ShipAddrLine2";
	private static final String P_TDS2_SHIP_ADDR_LINE3 = "Tds2ShipAddrLine3";
	private static final String P_TDS2_SHIP_ADDR_POST_CODE = "Tds2ShipAddrPostCode";
	private static final String P_TDS2_SHIP_ADDR_STATE = "Tds2ShipAddrState";
	private static final String P_TDS2_DELIVERY_EMAIL_ADDRESS = "Tds2DeliveryEmailAddress";
	private static final String P_TDS2_DELIVERY_TIMEFRAME = "Tds2DeliveryTimeframe";
	private static final String P_TDS2_GIFT_CARD_AMOUNT = "Tds2GiftCardAmount";
	private static final String P_TDS2_GIFT_CARD_COUNT = "Tds2GiftCardCount";
	private static final String P_TDS2_GIFT_CARD_CURR = "Tds2GiftCardCurr";
	private static final String P_TDS2_PRE_ORDER_DATE = "Tds2PreOrderDate";
	private static final String P_TDS2_PRE_ORDER_PURCHASE_IND = "Tds2PreOrderPurchaseInd";
	private static final String P_TDS2_REORDER_ITEMS_IND = "Tds2ReorderItemsInd";
	private static final String P_TDS2_SHIP_IND = "Tds2ShipInd";
	private static final String P_TDS2_RECURRING_EXPIRY = "Tds2RecurringExpiry";
	private static final String P_TDS2_RECURRING_FREQUENCY = "Tds2RecurringFrequency";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
	    	throws ServletException, IOException {
		doPost(req, res);
	}

    public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        ExecTranInput input = new ExecTranInput();
        ExecTranOutput output = null;

        // パラメータの設定
        input.setAccessId(req.getParameter(P_ACCESS_ID));
        input.setAccessPass(req.getParameter(P_ACCESS_PASS));
        input.setOrderId(req.getParameter(P_ORDER_ID));
        input.setMethod(Method.IKKATU);
        input.setCardNo(req.getParameter(P_CARD_NO));
        input.setToken(req.getParameter(P_TOKEN));
        input.setExpire(req.getParameter(P_EXPIRE));
		input.setHttpAccept(req.getHeader(H_ACCEPT));
		input.setHttpUserAgent(req.getHeader(H_USER_AGENT));
		input.setDeviceCategory(req.getParameter(P_DEVICE_CATEGORY));
        input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
        input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setClientFieldFlag(req.getParameter(P_CLIENT_FIELD_FLAG));
		input.setDisplayInfo(req.getParameter(P_DISPLAY_INFO));
		input.setTokenType(req.getParameter(P_TOKEN_TYPE));
		input.setRetUrl(req.getParameter(P_RET_URL));
		input.setAppMode(req.getParameter(P_APP_MODE));
		input.setTds2ChallengeIndType(req.getParameter(P_TDS2_CHALLENGE_IND_TYPE));
		input.setCallbackType(req.getParameter(P_CALLBACK_TYPE));
		input.setTds2ChAccChange(req.getParameter(P_TDS2_CH_ACC_CHANGE));
		input.setTds2ChAccDate(req.getParameter(P_TDS2_CH_ACC_DATE));
		input.setTds2ChAccPwChange(req.getParameter(P_TDS2_CH_ACC_PW_CHANGE));
        input.setTds2NbPurchaseAccount(
        		req.getParameter(P_TDS2_NB_PURCHASE_ACCOUNT) == null
        			? null : Integer.valueOf(req.getParameter(P_TDS2_NB_PURCHASE_ACCOUNT)));
		input.setTds2PaymentAccAge(req.getParameter(P_TDS2_PAYMENT_ACC_AGE));
		input.setTds2ProvisionAttemptsDay(
				req.getParameter(P_TDS2_PROVISION_ATTEMPTS_DAY) == null
					? null : Integer.valueOf(req.getParameter(P_TDS2_PROVISION_ATTEMPTS_DAY)));
		input.setTds2ShipAddressUsage(req.getParameter(P_TDS2_SHIP_ADDRESS_USAGE));
		input.setTds2ShipNameInd(req.getParameter(P_TDS2_SHIP_NAME_IND));
		input.setTds2SuspiciousAccActivity(req.getParameter(P_TDS2_SUSPICIOUS_ACC_ACTIVITY));
		input.setTds2TxnActivityDay(
				req.getParameter(P_TDS2_TXN_ACTIVITY_DAY) == null
					? null : Integer.valueOf(req.getParameter(P_TDS2_TXN_ACTIVITY_DAY)));
		input.setTds2TxnActivityYear(
				req.getParameter(P_TDS2_TXN_ACTIVITY_YEAR) == null
					? null : Integer.valueOf(req.getParameter(P_TDS2_TXN_ACTIVITY_YEAR)));
		input.setTds2ThreeDSReqAuthData(req.getParameter(P_TDS2_THREE_D_S_REQ_AUTH_DATA));
		input.setTds2ThreeDSReqAuthMethod(req.getParameter(P_TDS2_THREE_D_S_REQ_AUTH_METHOD));
		input.setTds2ThreeDSReqAuthTimestamp(req.getParameter(P_TDS2_THREE_D_S_REQ_AUTH_TIMESTAMP));
		input.setTds2AddrMatch(req.getParameter(P_TDS2_ADDR_MATCH));
		input.setTds2BillAddrCity(req.getParameter(P_TDS2_BILL_ADDR_CITY));
		input.setTds2BillAddrCountry(req.getParameter(P_TDS2_BILL_ADDR_COUNTRY));
		input.setTds2BillAddrLine1(req.getParameter(P_TDS2_BILL_ADDR_LINE1));
		input.setTds2BillAddrLine2(req.getParameter(P_TDS2_BILL_ADDR_LINE2));
		input.setTds2BillAddrLine3(req.getParameter(P_TDS2_BILL_ADDR_LINE3));
		input.setTds2BillAddrPostCode(req.getParameter(P_TDS2_BILL_ADDR_POST_CODE));
		input.setTds2BillAddrState(req.getParameter(P_TDS2_BILL_ADDR_STATE));
		input.setTds2Email(req.getParameter(P_TDS2_EMAIL));
		input.setTds2HomePhoneCC(req.getParameter(P_TDS2_HOME_PHONE_C_C));
		input.setTds2HomePhoneSubscriber(req.getParameter(P_TDS2_HOME_PHONE_SUBSCRIBER));
		input.setTds2MobilePhoneCC(req.getParameter(P_TDS2_MOBILE_PHONE_C_C));
		input.setTds2MobilePhoneSubscriber(req.getParameter(P_TDS2_MOBILE_PHONE_SUBSCRIBER));
		input.setTds2WorkPhoneCC(req.getParameter(P_TDS2_WORK_PHONE_C_C));
		input.setTds2WorkPhoneSubscriber(req.getParameter(P_TDS2_WORK_PHONE_SUBSCRIBER));
		input.setTds2ShipAddrCity(req.getParameter(P_TDS2_SHIP_ADDR_CITY));
		input.setTds2ShipAddrCountry(req.getParameter(P_TDS2_SHIP_ADDR_COUNTRY));
		input.setTds2ShipAddrLine1(req.getParameter(P_TDS2_SHIP_ADDR_LINE1));
		input.setTds2ShipAddrLine2(req.getParameter(P_TDS2_SHIP_ADDR_LINE2));
		input.setTds2ShipAddrLine3(req.getParameter(P_TDS2_SHIP_ADDR_LINE3));
		input.setTds2ShipAddrPostCode(req.getParameter(P_TDS2_SHIP_ADDR_POST_CODE));
		input.setTds2ShipAddrState(req.getParameter(P_TDS2_SHIP_ADDR_STATE));
		input.setTds2DeliveryEmailAddress(req.getParameter(P_TDS2_DELIVERY_EMAIL_ADDRESS));
		input.setTds2DeliveryTimeframe(req.getParameter(P_TDS2_DELIVERY_TIMEFRAME));
		input.setTds2GiftCardAmount(req.getParameter(P_TDS2_GIFT_CARD_AMOUNT));
		input.setTds2GiftCardCount(
				req.getParameter(P_TDS2_GIFT_CARD_COUNT) == null
					? null : Integer.valueOf(req.getParameter(P_TDS2_GIFT_CARD_COUNT)));
		input.setTds2GiftCardCurr(req.getParameter(P_TDS2_GIFT_CARD_CURR));
		input.setTds2PreOrderDate(req.getParameter(P_TDS2_PRE_ORDER_DATE));
		input.setTds2PreOrderPurchaseInd(req.getParameter(P_TDS2_PRE_ORDER_PURCHASE_IND));
		input.setTds2ReorderItemsInd(req.getParameter(P_TDS2_REORDER_ITEMS_IND));
		input.setTds2ShipInd(req.getParameter(P_TDS2_SHIP_IND));
		input.setTds2RecurringExpiry(req.getParameter(P_TDS2_RECURRING_EXPIRY));
		input.setTds2RecurringFrequency(
				req.getParameter(P_TDS2_RECURRING_FREQUENCY) == null
					? null : Integer.valueOf(req.getParameter(P_TDS2_RECURRING_FREQUENCY)));

		print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doExecTran(input);
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
        if (output.isErrorOccurred()) {
        	List list = output.getErrList();
    		print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
        		print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
        						new Object[]{eh.getErrCode(), eh.getErrInfo()}));

        	}
        } else {
    		print(out, "OUTPUT:");
        	print(out, "Acs: {0}", output.getAcs());
        	print(out, "Forward: {0}",	output.getForward());
        	print(out, "Method: {0}", output.getMethod());
        	print(out, "PayTimes: {0}", output.getPayTimes());
        	print(out, "Approve: {0}", output.getApprove());
        	print(out, "TranID: {0}", output.getTranId());
        	print(out, "TranDate: {0}", output.getTranDate());
        	print(out, "CheckString: {0}", output.getCheckString());
        	print(out, "ClientField1: {0}", output.getClientField1());
        	print(out, "ClientField2: {0}", output.getClientField2());
        	print(out, "ClientField3: {0}", output.getClientField3());
        	print(out, "ACSUrl: {0}", output.getAcsUrl());
        	print(out, "PaReq: {0}", output.getPaReq());
        	print(out, "MD: {0}", output.getMd());
        	print(out, "RedirectUrl: {0}", output.getRedirectUrl());
        }
        out.flush();
    }

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
