package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.JcbPrecaBalanceInquiryInput;
import com.gmo_pg.g_pay.client.output.JcbPrecaBalanceInquiryOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * JCBプリカ残高照会呼出サーブレットサンプルクラス
 */
public class CallJcbPrecaBalanceInquiryServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_CARD_NO = "CardNo";
	private static final String P_APPROVAL_NO = "ApprovalNo";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        JcbPrecaBalanceInquiryInput input = new JcbPrecaBalanceInquiryInput();
        JcbPrecaBalanceInquiryOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setCardNo(req.getParameter(P_CARD_NO));
		input.setApprovalNo(req.getParameter(P_APPROVAL_NO));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doJcbPrecaBalanceInquiry(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "CardNo: {0}", output.getCardNo());
			print(out, "Balance: {0}", output.getBalance());
			print(out, "CardActivateStatus: {0}", output.getCardActivateStatus());
			print(out, "CardTermStatus: {0}", output.getCardTermStatus());
			print(out, "CardInvalidStatus: {0}", output.getCardInvalidStatus());
			print(out, "CardWebInquiryStatus: {0}", output.getCardWebInquiryStatus());
			print(out, "CardValidLimit: {0}", output.getCardValidLimit());
			print(out, "CardTypeCode: {0}", output.getCardTypeCode());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
