package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.MerpaySearchPersonalDataInput;
import com.gmo_pg.g_pay.client.output.MerpaySearchPersonalDataOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * メルペイ個人情報参照呼出サーブレットサンプルクラス
 */
public class CallMerpaySearchPersonalDataServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ORDER_ID = "OrderID";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        MerpaySearchPersonalDataInput input = new MerpaySearchPersonalDataInput();
        MerpaySearchPersonalDataOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doMerpaySearchPersonalData(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "BuyerNickname: {0}", output.getBuyerNickname());
			print(out, "BuyerTel: {0}", output.getBuyerTel());
			print(out, "BuyerMail: {0}", output.getBuyerMail());
			print(out, "DeliveryFamilyName: {0}", output.getDeliveryFamilyName());
			print(out, "DeliveryFirstName: {0}", output.getDeliveryFirstName());
			print(out, "DeliveryFamilyNameKana: {0}", output.getDeliveryFamilyNameKana());
			print(out, "DeliveryFirstNameKana: {0}", output.getDeliveryFirstNameKana());
			print(out, "DeliveryTel: {0}", output.getDeliveryTel());
			print(out, "DeleveryZipCode: {0}", output.getDeleveryZipCode());
			print(out, "DeliveryPrefecture: {0}", output.getDeliveryPrefecture());
			print(out, "DeliveryCity: {0}", output.getDeliveryCity());
			print(out, "DeliveryAddress1: {0}", output.getDeliveryAddress1());
			print(out, "DeliveryAddress2: {0}", output.getDeliveryAddress2());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
