package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.PaypalStartInput;
import com.gmo_pg.g_pay.client.input.PaypalStartParam;

/**
 * Paypal支払開始サンプルサーブレットクラス
 *
 * @author GMO PaymentGateway
 * @version 1.0
 * @modified 2009/12/17
 */
public class CallPaypalStartServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_ACCESS_ID = "AccessID";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		PaypalStartInput input = new PaypalStartInput();
		String output = null;

		// パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setAccessID(req.getParameter(P_ACCESS_ID));

		PaypalStartParam paypalStartParam = new PaypalStartParam();
		paypalStartParam.setShopId(input.getShopID());
		paypalStartParam.setAccessId(input.getAccessID());

		print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doPaypalStart("conf/DoPaypalStartRedirect.html",
					paypalStartParam, "Windows-31J");
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果出力
		print(out, "OUTPUT:");
		print(out, output);
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		System.out.println(str);
		out.print(str);
		out.println();
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}