package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.PostpayChangeInput;
import com.gmo_pg.g_pay.client.output.PostpayChangeOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * PS後払い決済変更呼出サーブレットサンプルクラス
 */
public class CallPostpayChangeServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_AMOUNT = "Amount";
	private static final String P_TAX = "Tax";
	private static final String P_CUSTOMER_ORDER_DATE = "CustomerOrderDate";
	private static final String P_CUSTOMER_NAME = "CustomerName";
	private static final String P_CUSTOMER_NAME_KANA = "CustomerNameKana";
	private static final String P_CUSTOMER_ZIP_CODE = "CustomerZipCode";
	private static final String P_CUSTOMER_ADDRESS = "CustomerAddress";
	private static final String P_CUSTOMER_COMPANY_NAME = "CustomerCompanyName";
	private static final String P_CUSTOMER_DEPARTMENT_NAME = "CustomerDepartmentName";
	private static final String P_CUSTOMER_TEL1 = "CustomerTel1";
	private static final String P_CUSTOMER_TEL2 = "CustomerTel2";
	private static final String P_CUSTOMER_EMAIL1 = "CustomerEmail1";
	private static final String P_CUSTOMER_EMAIL2 = "CustomerEmail2";
	private static final String P_CUSTOMER_PAYMENT_TYPE = "CustomerPaymentType";
	private static final String P_CUSTOMER_SEX = "CustomerSex";
	private static final String P_CUSTOMER_BIRTHDAY = "CustomerBirthday";
	private static final String P_CUSTOMER_REGIST_DATE = "CustomerRegistDate";
	private static final String P_CUSTOMER_BUY_COUNT = "CustomerBuyCount";
	private static final String P_CUSTOMER_BUY_AMOUNT_TOTAL = "CustomerBuyAmountTotal";
	private static final String P_CUSTOMER_ID = "CustomerID";
	private static final String P_DELIVERY_NAME = "DeliveryName";
	private static final String P_DELIVERY_NAME_KANA = "DeliveryNameKana";
	private static final String P_DELIVERY_ZIP_CODE = "DeliveryZipCode";
	private static final String P_DELIVERY_ADRESS = "DeliveryAdress";
	private static final String P_DELIVERY_COMPANY_NAME = "DeliveryCompanyName";
	private static final String P_DELIVERY_DEPARTMENT_NAME = "DeliveryDepartmentName";
	private static final String P_DELIVERY_TEL = "DeliveryTel";
	private static final String P_DETAIL_NAME = "DetailName";
	private static final String P_DETAIL_PRICE = "DetailPrice";
	private static final String P_DETAIL_QUANTITY = "DetailQuantity";
	private static final String P_DETAIL_BRAND = "DetailBrand";
	private static final String P_DETAIL_CATEGORY = "DetailCategory";
	private static final String P_MULTI_ITEM = "MultiItem";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        PostpayChangeInput input = new PostpayChangeInput();
        PostpayChangeOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setAmount(req.getParameter(P_AMOUNT));
		input.setTax(req.getParameter(P_TAX));
		input.setCustomerOrderDate(req.getParameter(P_CUSTOMER_ORDER_DATE));
		input.setCustomerName(req.getParameter(P_CUSTOMER_NAME));
		input.setCustomerNameKana(req.getParameter(P_CUSTOMER_NAME_KANA));
		input.setCustomerZipCode(req.getParameter(P_CUSTOMER_ZIP_CODE));
		input.setCustomerAddress(req.getParameter(P_CUSTOMER_ADDRESS));
		input.setCustomerCompanyName(req.getParameter(P_CUSTOMER_COMPANY_NAME));
		input.setCustomerDepartmentName(req.getParameter(P_CUSTOMER_DEPARTMENT_NAME));
		input.setCustomerTel1(req.getParameter(P_CUSTOMER_TEL1));
		input.setCustomerTel2(req.getParameter(P_CUSTOMER_TEL2));
		input.setCustomerEmail1(req.getParameter(P_CUSTOMER_EMAIL1));
		input.setCustomerEmail2(req.getParameter(P_CUSTOMER_EMAIL2));
		input.setCustomerPaymentType(req.getParameter(P_CUSTOMER_PAYMENT_TYPE));
		input.setCustomerSex(req.getParameter(P_CUSTOMER_SEX));
		input.setCustomerBirthday(req.getParameter(P_CUSTOMER_BIRTHDAY));
		input.setCustomerRegistDate(req.getParameter(P_CUSTOMER_REGIST_DATE));
		input.setCustomerBuyCount(req.getParameter(P_CUSTOMER_BUY_COUNT));
		input.setCustomerBuyAmountTotal(req.getParameter(P_CUSTOMER_BUY_AMOUNT_TOTAL));
		input.setCustomerID(req.getParameter(P_CUSTOMER_ID));
		input.setDeliveryName(req.getParameter(P_DELIVERY_NAME));
		input.setDeliveryNameKana(req.getParameter(P_DELIVERY_NAME_KANA));
		input.setDeliveryZipCode(req.getParameter(P_DELIVERY_ZIP_CODE));
		input.setDeliveryAdress(req.getParameter(P_DELIVERY_ADRESS));
		input.setDeliveryCompanyName(req.getParameter(P_DELIVERY_COMPANY_NAME));
		input.setDeliveryDepartmentName(req.getParameter(P_DELIVERY_DEPARTMENT_NAME));
		input.setDeliveryTel(req.getParameter(P_DELIVERY_TEL));
		input.setDetailName(req.getParameter(P_DETAIL_NAME));
		input.setDetailPrice(req.getParameter(P_DETAIL_PRICE));
		input.setDetailQuantity(req.getParameter(P_DETAIL_QUANTITY));
		input.setDetailBrand(req.getParameter(P_DETAIL_BRAND));
		input.setDetailCategory(req.getParameter(P_DETAIL_CATEGORY));
		input.setMultiItem(req.getParameter(P_MULTI_ITEM));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doPostpayChange(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "Status: {0}", output.getStatus());
			print(out, "TranDate: {0}", output.getTranDate());
			print(out, "PostpayTransactionId: {0}", output.getPostpayTransactionId());
			print(out, "CheckString: {0}", output.getCheckString());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
