package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.PostpayReissueInvoiceInput;
import com.gmo_pg.g_pay.client.output.PostpayReissueInvoiceOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * PS後払い請求書再発行申請呼出サーブレットサンプルクラス
 */
public class CallPostpayReissueInvoiceServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_DESTINATION_TYPE = "DestinationType";
	private static final String P_REASON_CODE = "ReasonCode";
	private static final String P_OTHER_REASON = "OtherReason";
	private static final String P_CUSTOMER_ORDER_DATE = "CustomerOrderDate";
	private static final String P_CUSTOMER_NAME = "CustomerName";
	private static final String P_CUSTOMER_NAME_KANA = "CustomerNameKana";
	private static final String P_CUSTOMER_ZIP_CODE = "CustomerZipCode";
	private static final String P_CUSTOMER_ADDRESS = "CustomerAddress";
	private static final String P_CUSTOMER_COMPANY_NAME = "CustomerCompanyName";
	private static final String P_CUSTOMER_DEPARTMENT_NAME = "CustomerDepartmentName";
	private static final String P_CUSTOMER_TEL1 = "CustomerTel1";
	private static final String P_CUSTOMER_TEL2 = "CustomerTel2";
	private static final String P_CUSTOMER_EMAIL1 = "CustomerEmail1";
	private static final String P_CUSTOMER_EMAIL2 = "CustomerEmail2";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        PostpayReissueInvoiceInput input = new PostpayReissueInvoiceInput();
        PostpayReissueInvoiceOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setAccessID(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setDestinationType(req.getParameter(P_DESTINATION_TYPE));
		input.setReasonCode(req.getParameter(P_REASON_CODE));
		input.setOtherReason(req.getParameter(P_OTHER_REASON));
		input.setCustomerOrderDate(req.getParameter(P_CUSTOMER_ORDER_DATE));
		input.setCustomerName(req.getParameter(P_CUSTOMER_NAME));
		input.setCustomerNameKana(req.getParameter(P_CUSTOMER_NAME_KANA));
		input.setCustomerZipCode(req.getParameter(P_CUSTOMER_ZIP_CODE));
		input.setCustomerAddress(req.getParameter(P_CUSTOMER_ADDRESS));
		input.setCustomerCompanyName(req.getParameter(P_CUSTOMER_COMPANY_NAME));
		input.setCustomerDepartmentName(req.getParameter(P_CUSTOMER_DEPARTMENT_NAME));
		input.setCustomerTel1(req.getParameter(P_CUSTOMER_TEL1));
		input.setCustomerTel2(req.getParameter(P_CUSTOMER_TEL2));
		input.setCustomerEmail1(req.getParameter(P_CUSTOMER_EMAIL1));
		input.setCustomerEmail2(req.getParameter(P_CUSTOMER_EMAIL2));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doPostpayReissueInvoice(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "Status: {0}", output.getStatus());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
