package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SaveCardInput;
import com.gmo_pg.g_pay.client.output.ErrHolder;
import com.gmo_pg.g_pay.client.output.SaveCardOutput;

/**
 * カード登録呼び出しサーブレットサンプルクラス
 */
public class CallSaveCardServlet extends HttpServlet {

	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_CARD_SEQ = "CardSeq";
	private static final String P_DEFAULT_FLAG = "DefaultFlag";
	private static final String P_CARD_NAME = "CardName";
	private static final String P_CARD_NO = "CardNo";
	private static final String P_TOKEN = "Token";
	private static final String P_CARD_PASS = "CardPass";
	private static final String P_EXPIRE = "Expire";
	private static final String P_HOLDER_NAME = "HolderName";
	private static final String P_UPDATE_TYPE = "UpdateType";
	private static final String P_SEQ_MODE = "SeqMode";
	private static final String P_SRC_MEMBER_ID = "SrcMemberID";
	private static final String P_SRC_CARD_SEQ = "SrcCardSeq";
	private static final String P_SECURITY_CODE = "SecurityCode";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		SaveCardInput input = new SaveCardInput();
		SaveCardOutput output = null;

		// パラメータの設定
		input.setSiteId(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setMemberId(req.getParameter(P_MEMBER_ID));
		if (req.getParameter(P_CARD_SEQ) != null) {

			if ("".equals(req.getParameter(P_CARD_SEQ))) {
				input.setCardSeq(null);
			} else {
				input.setCardSeq(Integer.valueOf(req.getParameter(P_CARD_SEQ)));
			}
		}
		input.setDefaultFlag(req.getParameter(P_DEFAULT_FLAG));
		input.setCardName(req.getParameter(P_CARD_NAME));
		input.setCardNo(req.getParameter(P_CARD_NO));
		input.setToken(req.getParameter(P_TOKEN));
		input.setCardPass(req.getParameter(P_CARD_PASS));
		input.setExpire(req.getParameter(P_EXPIRE));
		input.setHolderName(req.getParameter(P_HOLDER_NAME));
		input.setSeqMode(req.getParameter(P_SEQ_MODE));
		input.setUpdateType(req.getParameter(P_UPDATE_TYPE));
		input.setSrcMemberID(req.getParameter(P_SRC_MEMBER_ID));
		input.setSrcCardSeq(req.getParameter(P_SRC_CARD_SEQ));
		input.setSecurityCode(req.getParameter(P_SECURITY_CODE));
		print(out, "INPUT: {0}",
				input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSaveCard(input);
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
								new Object[]{eh.getErrCode(), eh.getErrInfo()}));
			}
		} else {
			print(out, "OUTPUT:");
	        print(out, "CardSeq: {0}", output.getCardSeq());
	        print(out, "CardNo: {0}", output.getCardNo());
	        print(out, "Forward: {0}", output.getForward());
	        print(out, "Brand: {0}", output.getBrand());
	        print(out, "DomesticFlag: {0}", output.getDomesticFlag());
	        print(out, "IssuerCode: {0}", output.getIssuerCode());
	        print(out, "DebitPrepaidFlag: {0}", output.getDebitPrepaidFlag());
	        print(out, "DebitPrepaidIssuerName: {0}", output.getDebitPrepaidIssuerName());
	        print(out, "ForwardFinal: {0}", output.getForwardFinal());
		}
		out.flush();
}

	private void print(PrintWriter out, String str) {
		v(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		v(out, fmt, new Object[]{obj});
	}

	private void v(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}