package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SavePaidBuyerInput;
import com.gmo_pg.g_pay.client.output.SavePaidBuyerOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;

import java.math.BigDecimal;

/**
 * Paid取引先登録呼出サーブレットサンプルクラス
 */
public class CallSavePaidBuyerServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_PAID_BUYER_ID = "PaidBuyerID";
	private static final String P_COMPANY_NAME = "CompanyName";
	private static final String P_COMPANY_NAME_KANA = "CompanyNameKana";
	private static final String P_REPRESENTATIVE_SEI = "RepresentativeSei";
	private static final String P_REPRESENTATIVE_MEI = "RepresentativeMei";
	private static final String P_REPRESENTATIVE_SEI_KANA = "RepresentativeSeiKana";
	private static final String P_REPRESENTATIVE_MEI_KANA = "RepresentativeMeiKana";
	private static final String P_ZIP_CODE = "ZipCode";
	private static final String P_PREFECTURE = "Prefecture";
	private static final String P_ADDRESS1 = "Address1";
	private static final String P_ADDRESS2 = "Address2";
	private static final String P_ADDRESS3 = "Address3";
	private static final String P_AUX_NAME = "AuxName";
	private static final String P_CLERK_SEI = "ClerkSei";
	private static final String P_CLERK_MEI = "ClerkMei";
	private static final String P_CLERK_SEI_KANA = "ClerkSeiKana";
	private static final String P_CLERK_MEI_KANA = "ClerkMeiKana";
	private static final String P_TEL = "Tel";
	private static final String P_FAX = "Fax";
	private static final String P_MOBILE_TEL = "MobileTel";
	private static final String P_EMAIL = "Email";
	private static final String P_ESTABLISHED_YEAR = "EstablishedYear";
	private static final String P_ESTABLISHED_MONTH = "EstablishedMonth";
	private static final String P_ANNUAL_SALES = "AnnualSales";
	private static final String P_BUSINESS_DETAIL_TYPE = "BusinessDetailType";
	private static final String P_DEALING_BRAND = "DealingBrand";
	private static final String P_SHOP_COUNT = "ShopCount";
	private static final String P_URL1 = "Url1";
	private static final String P_URL2 = "Url2";
	private static final String P_URL3 = "Url3";
	private static final String P_PROFILE = "Profile";
	private static final String P_CLOSING_DAY = "ClosingDay";
	private static final String P_PAYMENT_METHOD = "PaymentMethod";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        SavePaidBuyerInput input = new SavePaidBuyerInput();
        SavePaidBuyerOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setPaidBuyerID(req.getParameter(P_PAID_BUYER_ID));
		input.setCompanyName(req.getParameter(P_COMPANY_NAME));
		input.setCompanyNameKana(req.getParameter(P_COMPANY_NAME_KANA));
		input.setRepresentativeSei(req.getParameter(P_REPRESENTATIVE_SEI));
		input.setRepresentativeMei(req.getParameter(P_REPRESENTATIVE_MEI));
		input.setRepresentativeSeiKana(req.getParameter(P_REPRESENTATIVE_SEI_KANA));
		input.setRepresentativeMeiKana(req.getParameter(P_REPRESENTATIVE_MEI_KANA));
		input.setZipCode(req.getParameter(P_ZIP_CODE));
		input.setPrefecture(req.getParameter(P_PREFECTURE));
		input.setAddress1(req.getParameter(P_ADDRESS1));
		input.setAddress2(req.getParameter(P_ADDRESS2));
		input.setAddress3(req.getParameter(P_ADDRESS3));
		input.setAuxName(req.getParameter(P_AUX_NAME));
		input.setClerkSei(req.getParameter(P_CLERK_SEI));
		input.setClerkMei(req.getParameter(P_CLERK_MEI));
		input.setClerkSeiKana(req.getParameter(P_CLERK_SEI_KANA));
		input.setClerkMeiKana(req.getParameter(P_CLERK_MEI_KANA));
		input.setTel(req.getParameter(P_TEL));
		input.setFax(req.getParameter(P_FAX));
		input.setMobileTel(req.getParameter(P_MOBILE_TEL));
		input.setEmail(req.getParameter(P_EMAIL));
		input.setEstablishedYear(
				req.getParameter(P_ESTABLISHED_YEAR) == null || req.getParameter(P_ESTABLISHED_YEAR).length() == 0
					? null : new Integer(req.getParameter(P_ESTABLISHED_YEAR)));

		input.setEstablishedMonth(
				req.getParameter(P_ESTABLISHED_MONTH) == null || req.getParameter(P_ESTABLISHED_MONTH).length() == 0
					? null : new Integer(req.getParameter(P_ESTABLISHED_MONTH)));

		input.setAnnualSales(
				req.getParameter(P_ANNUAL_SALES) == null || req.getParameter(P_ANNUAL_SALES).length() == 0
					? null : new Integer(req.getParameter(P_ANNUAL_SALES)));

		input.setBusinessDetailType(
				req.getParameter(P_BUSINESS_DETAIL_TYPE) == null || req.getParameter(P_BUSINESS_DETAIL_TYPE).length() == 0
					? null : new Integer(req.getParameter(P_BUSINESS_DETAIL_TYPE)));

		input.setDealingBrand(req.getParameter(P_DEALING_BRAND));
		input.setShopCount(
				req.getParameter(P_SHOP_COUNT) == null || req.getParameter(P_SHOP_COUNT).length() == 0
					? null : new BigDecimal(req.getParameter(P_SHOP_COUNT)));

		input.setUrl1(req.getParameter(P_URL1));
		input.setUrl2(req.getParameter(P_URL2));
		input.setUrl3(req.getParameter(P_URL3));
		input.setProfile(req.getParameter(P_PROFILE));
		input.setClosingDay(req.getParameter(P_CLOSING_DAY));
		input.setPaymentMethod(req.getParameter(P_PAYMENT_METHOD));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSavePaidBuyer(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "PaidBuyerID: {0}", output.getPaidBuyerID());
			print(out, "PaidID: {0}", output.getPaidID());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
