package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SearchBankAccountPaperEntryInput;
import com.gmo_pg.g_pay.client.output.SearchBankAccountPaperEntryOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * 口座振替ペーパー申込口座登録依頼書データ照会呼出サーブレットサンプルクラス
 */
public class CallSearchBankAccountPaperEntryServlet extends HttpServlet {

	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_TRAN_ID = "TranID";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        SearchBankAccountPaperEntryInput input = new SearchBankAccountPaperEntryInput();
        SearchBankAccountPaperEntryOutput output = null;

        // パラメータの設定
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setTranID(req.getParameter(P_TRAN_ID));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSearchBankAccountPaperEntry(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "TranID: {0}", output.getTranID());
			print(out, "Status: {0}", output.getStatus());
			print(out, "SiteID: {0}", output.getSiteID());
			print(out, "MemberID: {0}", output.getMemberID());
			print(out, "RegistDate: {0}", output.getRegistDate());
			print(out, "RegistUser: {0}", output.getRegistUser());
			print(out, "ConfirmDate: {0}", output.getConfirmDate());
			print(out, "ConfirmUser: {0}", output.getConfirmUser());
			print(out, "NgDate: {0}", output.getNgDate());
			print(out, "NgReason: {0}", output.getNgReason());
			print(out, "NgNote: {0}", output.getNgNote());
			print(out, "FinancialInstituteType: {0}", output.getFinancialInstituteType());
			print(out, "BankCode: {0}", output.getBankCode());
			print(out, "BankName: {0}", output.getBankName());
			print(out, "BranchCode: {0}", output.getBranchCode());
			print(out, "BranchName: {0}", output.getBranchName());
			print(out, "AccountType: {0}", output.getAccountType());
			print(out, "AccountOwnerType: {0}", output.getAccountOwnerType());
			print(out, "AccountNameSei: {0}", output.getAccountNameSei());
			print(out, "AccountNameMei: {0}", output.getAccountNameMei());
			print(out, "AccountNameSeiKana: {0}", output.getAccountNameSeiKana());
			print(out, "AccountNameMeiKana: {0}", output.getAccountNameMeiKana());
			print(out, "AccountNameBisiness: {0}", output.getAccountNameBisiness());
			print(out, "AccountNameBisinessKana: {0}", output.getAccountNameBisinessKana());
			print(out, "AccountNumber: {0}", output.getAccountNumber());
			print(out, "PostalAccountNumber1: {0}", output.getPostalAccountNumber1());
			print(out, "PostalAccountNumber2: {0}", output.getPostalAccountNumber2());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
