package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SearchCardDetailInput;
import com.gmo_pg.g_pay.client.output.SearchCardDetailOutput;
import com.gmo_pg.g_pay.client.output.SearchCardDetailOutput.CardInfo;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * カード情報詳細カード詳細情報取得呼出サーブレットサンプルクラス
 */
public class CallSearchCardDetailServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_CARD_NO = "CardNo";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_SEQ_MODE = "SeqMode";
	private static final String P_CARD_SEQ = "CardSeq";
	private static final String P_TOKEN = "Token";
	private static final String P_SEARCH_TYPE = "SearchType";
	private static final String P_USE_FLOATING_MASK = "useFloatingMask";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        SearchCardDetailInput input = new SearchCardDetailInput();
        SearchCardDetailOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setCardNo(req.getParameter(P_CARD_NO));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setMemberID(req.getParameter(P_MEMBER_ID));
		input.setSeqMode(req.getParameter(P_SEQ_MODE));
		input.setToken(req.getParameter(P_TOKEN));
		input.setSearchType(req.getParameter(P_SEARCH_TYPE));
		input.setUseFloatingMask(req.getParameter(P_USE_FLOATING_MASK));

		if (req.getParameter(P_SEARCH_TYPE) != null) {

			if ("".equals(req.getParameter(P_SEARCH_TYPE))) {
				input.setSearchType(null);
			} else {
				input.setSearchType(req.getParameter(P_SEARCH_TYPE));
			}
		}

		if (req.getParameter(P_CARD_SEQ) != null) {

			if ("".equals(req.getParameter(P_CARD_SEQ))) {
				input.setCardSeq(null);
			} else {
				input.setCardSeq(req.getParameter(P_CARD_SEQ));
			}
		}

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSearchCardDetail(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			List list = output.getCardList();
			print(out, "OUTPUT:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				CardInfo info = (CardInfo)it.next();
				print(out, "CardNo: {0}", info.getCardNo());
				print(out, "Brand: {0}", info.getBrand());
				print(out, "DomesticFlag: {0}", info.getDomesticFlag());
				print(out, "IssuerCode: {0}", info.getIssuerCode());
				print(out, "DebitPrepaidFlag: {0}", info.getDebitPrepaidFlag());
				print(out, "DebitPrepaidIssuerName: {0}", info.getDebitPrepaidIssuerName());
				print(out, "ForwardFinal: {0}", info.getForwardFinal());
				if(input.getSearchType() != null && input.getSearchType().equals("1")) {
					print(out, "Info1: {0}", info.getInfo1());
					print(out, "Info2: {0}", info.getInfo2());
					print(out, "Info3: {0}", info.getInfo3());
					print(out, "Info4: {0}", info.getInfo4());
					print(out, "Info5: {0}", info.getInfo5());
				}
		        print(out, "----------");
			}
		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
