package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SearchRecurringResultInput;
import com.gmo_pg.g_pay.client.output.SearchRecurringResultOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * 自動売上自動売上結果照会呼出サーブレットサンプルクラス
 */
public class CallSearchRecurringResultServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_RECURRING_ID = "RecurringID";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        SearchRecurringResultInput input = new SearchRecurringResultInput();
        SearchRecurringResultOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setRecurringID(req.getParameter(P_RECURRING_ID));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSearchRecurringResult(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "Method: {0}", output.getMethod());
			print(out, "ShopID: {0}", output.getShopID());
			print(out, "RecurringID: {0}", output.getRecurringID());
			print(out, "OrderID: {0}", output.getOrderID());
			print(out, "ChargeDate: {0}", output.getChargeDate());
			print(out, "Status: {0}", output.getStatus());
			print(out, "Amount: {0}", output.getAmount());
			print(out, "Tax: {0}", output.getTax());
			print(out, "NextChargeDate: {0}", output.getNextChargeDate());
			print(out, "AccessID: {0}", output.getAccessID());
			print(out, "AccessPass: {0}", output.getAccessPass());
			print(out, "Forward: {0}", output.getForward());
			print(out, "ApprovalNo: {0}", output.getApprovalNo());
			print(out, "SiteID: {0}", output.getSiteID());
			print(out, "MemberID: {0}", output.getMemberID());
			print(out, "PrintStr: {0}", output.getPrintStr());
			print(out, "Remarks: {0}", output.getRemarks());
			print(out, "Result: {0}", output.getResult());
			print(out, "ChargeErrCode: {0}", output.getChargeErrCode());
			print(out, "ChargeErrInfo: {0}", output.getChargeErrInfo());
			print(out, "ProcessDate: {0}", output.getProcessDate());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
