package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SearchTradeMultiInput;
import com.gmo_pg.g_pay.client.output.ErrHolder;
import com.gmo_pg.g_pay.client.output.SearchTradeMultiOutput;

/**
 * 取引状態照会マルチ呼び出しサーブレットサンプルクラス
 *
 * @author GMO PaymentGateway
 */
public class CallSearchTradeMultiServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_PAYTYPE = "PayType";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		SearchTradeMultiInput input = new SearchTradeMultiInput();
		SearchTradeMultiOutput output = null;

		// パラメータの設定
        input.setShopId(req.getParameter(P_SHOP_ID));
        input.setShopPass(req.getParameter(P_SHOP_PASS));
        input.setOrderId(req.getParameter(P_ORDER_ID));
        input.setPayType(req.getParameter(P_PAYTYPE));
		print(out, "INPUT: {0}",
				input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSearchTradeMulti(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
								new Object[]{eh.getErrCode(), eh.getErrInfo()}));
			}
		} else {
			print(out, "OUTPUT:");
            print(out, "OrderID: {0}", output.getOrderId());
            print(out, "Status: {0}", output.getStatus());
            print(out, "ProcessDate: {0}", output.getProcessDate());
            print(out, "JobCd: {0}", output.getJobCd());
	        print(out, "AccessID: {0}", output.getAccessId());
	        print(out, "AccessPass: {0}", output.getAccessPass());
            print(out, "ItemCode: {0}", output.getItemCode());
            print(out, "Currency: {0}", output.getCurrency());
            print(out, "Amount: {0}", output.getAmount());
            print(out, "Tax: {0}", output.getTax());
            print(out, "AmountBigDecimal: {0}", output.getAmountBigDecimal());
            print(out, "TaxBigDecimal: {0}", output.getTaxBigDecimal());
            print(out, "SiteID: {0}", output.getSiteId());
            print(out, "MemberID: {0}", output.getMemberId());
            print(out, "CardNo: {0}", output.getCardNo());
            print(out, "Expire: {0}", output.getExpire());
            print(out, "Method: {0}", output.getMethod());
            print(out, "PayTimes: {0}", output.getPayTimes());
	        print(out, "Forward: {0}", output.getForward());
            print(out, "TranID: {0}", output.getTranId());
	        print(out, "Approve: {0}", output.getApprove());
            print(out, "ClientField1: {0}", output.getClientField1());
            print(out, "ClientField2: {0}", output.getClientField2());
            print(out, "ClientField3: {0}", output.getClientField3());

            print(out, "PayType: {0}", output.getPayType());
            print(out, "CvsCode: {0}", output.getCvsCode());
            print(out, "CvsConfNo: {0}", output.getCvsConfNo());
            print(out, "CvsReceiptNo: {0}", output.getCvsReceiptNo());
            print(out, "EdyReceiptNo: {0}", output.getEdyReceiptNo());
            print(out, "EdyOrderNo: {0}", output.getEdyOrderNo());
            print(out, "SuicaReceiptNo: {0}", output.getSuicaReceiptNo());
            print(out, "SuicaOrderNo: {0}", output.getSuicaOrderNo());
            print(out, "CustId: {0}", output.getCustId());
            print(out, "BkCode: {0}", output.getBkCode());
            print(out, "ConfNo: {0}", output.getConfNo());
            print(out, "EncryptReceiptNo: {0}", output.getEncryptReceiptNo());
            print(out, "PaymentTerm: {0}", output.getPaymentTerm());
            print(out, "PayeasyPaymentURL: {0}", output.getPayeasyPaymentURL());
            print(out, "WebMoneyManagementNo: {0}", output.getWebMoneyManagementNo());
            print(out, "WebMoneySettleCode: {0}", output.getWebMoneySettleCode());

            print(out, "AuPayInfoNo: {0}", output.getAuPayInfoNo());
            print(out, "AuPayMethod: {0}", output.getAuPayMethod());
            print(out, "AuCancelAmount: {0}", output.getAuCancelAmount());
            print(out, "AuCancelTax: {0}", output.getAuCancelTax());

			print(out, "DocomoSettlementCode: {0}", output.getDocomoSettlementCode());
			print(out, "DocomoCancelAmount: {0}", output.getDocomoCancelAmount());
			print(out, "DocomoCancelTax: {0}", output.getDocomoCancelTax());
			print(out, "DocomoIncreaseAmount: {0}", output.getDocomoIncreaseAmount());
			print(out, "DocomoIncreaseTax: {0}", output.getDocomoIncreaseTax());

			print(out, "SbTrackingId: {0}", output.getSbTrackingId());
			print(out, "SbCancelAmount: {0}", output.getSbCancelAmount());
			print(out, "SbCancelTax: {0}", output.getSbCancelTax());

			print(out, "JibunReceiptNo: {0}", output.getJibunReceiptNo());

			print(out, "FirstAmount: {0}", output.getFirstAmount());
			print(out, "FirstTax: {0}", output.getFirstTax());
			print(out, "AccountTimingKbn: {0}", output.getAccountTimingKbn());
			print(out, "AccountTiming: {0}", output.getAccountTiming());
			print(out, "FirstAccountDate: {0}", output.getFirstAccountDate());
			print(out, "AuContinuanceErrCode: {0}", output.getAuContinuanceErrCode());
			print(out, "AuContinuanceErrInfo: {0}", output.getAuContinuanceErrInfo());
			print(out, "AuContinueAccountId: {0}", output.getAuContinueAccountId());
			print(out, "ProcessLastDate: {0}", output.getProcessLastDate());

			print(out, "TotalIncreaseAmount: {0}", output.getTotalIncreaseAmount());
			print(out, "TotalIncreaseTax: {0}", output.getTotalIncreaseTax());
			print(out, "DccAmount: {0}", output.getDccAmount());
			print(out, "DccFtn: {0}", output.getDccFtn());
			print(out, "PaypalPaymentType: {0}", output.getPaypalPaymentType());
			print(out, "PaypalAgreementCurrentstatus: {0}", output.getPaypalAgreementCurrentstatus());
			print(out, "PaypalAgreementID: {0}", output.getPaypalAgreementId());
			print(out, "PaypalBillingAgreementID: {0}", output.getPaypalBillingAgreementId());
			print(out, "PaypalAgreementStartDate: {0}", output.getPaypalAgreementStartDate());
			print(out, "PaypalAgreementEndDate: {0}", output.getPaypalAgreementEndDate());

			print(out, "JcbPrecaSalesCode: {0}", output.getJcbPrecaSalesCode());
			print(out, "NetCashPayType: {0}", output.getNetCashPayType());
			print(out, "OrderDate: {0}", output.getOrderDate());
			print(out, "CompletionDate: {0}", output.getCompletionDate());
			print(out, "RakutenidCouponFee: {0}", output.getRakutenidCouponFee());
			print(out, "SubscriptionId: {0}", output.getSubscriptionId());
			print(out, "SettlementSubscriptionId: {0}", output.getSettlementSubscriptionId());
			print(out, "LinepayProductName: {0}", output.getLinepayProductName());
			print(out, "LinepayCancelAmount: {0}", output.getLinepayCancelAmount());
			print(out, "LinepayCancelTax: {0}", output.getLinepayCancelTax());
			print(out, "LinepayPayMethod: {0}", output.getLinepayPayMethod());
			print(out, "LinepayRegKey: {0}", output.getLinepayRegKey());
			print(out, "LinepaySettlementRegKey: {0}", output.getLinepaySettlementRegKey());
			print(out, "CommodityName: {0}", output.getCommodityName());
			print(out, "SbStartChargeMonth: {0}", output.getSbStartChargeMonth());
			print(out, "VaRequestAmount: {0}", output.getVaRequestAmount());
			print(out, "VaExpireDate: {0}", output.getVaExpireDate());
			print(out, "VaTradeReason: {0}", output.getVaTradeReason());
			print(out, "VaTradeClientName: {0}", output.getVaTradeClientName());
			print(out, "VaTradeClientMailaddress: {0}", output.getVaTradeClientMailaddress());
			print(out, "VaBankCode: {0}", output.getVaBankCode());
			print(out, "VaBankName: {0}", output.getVaBankName());
			print(out, "VaBranchCode: {0}", output.getVaBranchCode());
			print(out, "VaBranchName: {0}", output.getVaBranchName());
			print(out, "VaAccountType: {0}", output.getVaAccountType());
			print(out, "VaAccountNumber: {0}", output.getVaAccountNumber());
			print(out, "VaInInquiryNumber: {0}", output.getVaInInquiryNumber());
			print(out, "VaInSettlementDate: {0}", output.getVaInSettlementDate());
			print(out, "VaInAmount: {0}", output.getVaInAmount());
			print(out, "VaInClientCode: {0}", output.getVaInClientCode());
			print(out, "VaInClientName: {0}", output.getVaInClientName());
			print(out, "VaInSummary: {0}", output.getVaInSummary());
			print(out, "VaReserveID: {0}", output.getVaReserveID());
			print(out, "VaTradeCode: {0}", output.getVaTradeCode());
			print(out, "RcOrderId: {0}", output.getRcOrderId());
			print(out, "RcCustomerId: {0}", output.getRcCustomerId());
			print(out, "RcOrderTime: {0}", output.getRcOrderTime());
			print(out, "RcUsePoint: {0}", output.getRcUsePoint());
			print(out, "RcUseCoupon: {0}", output.getRcUseCoupon());
			print(out, "RcUseShopCoupon: {0}", output.getRcUseShopCoupon());
			print(out, "RcUpdateAuthDay: {0}", output.getRcUpdateAuthDay());
			print(out, "RcContractId: {0}", output.getRcContractId());
			print(out, "RcStartChargeMonth: {0}", output.getRcStartChargeMonth());
			print(out, "CardNoToken: {0}", output.getCardNoToken());
			print(out, "BaTargetDate: {0}", output.getBaTargetDate());
			print(out, "BaRequestAcceptEndDate: {0}", output.getBaRequestAcceptEndDate());
			print(out, "BaTransferReturnDate: {0}", output.getBaTransferReturnDate());
			print(out, "BaWithdrawalDate: {0}", output.getBaWithdrawalDate());
			print(out, "BaResultCode: {0}", output.getBaResultCode());
			print(out, "PaidCancelAmount: {0}", output.getPaidCancelAmount());
			print(out, "PaidCancelTax: {0}", output.getPaidCancelTax());
			print(out, "PaidBuyerID: {0}", output.getPaidBuyerID());
			print(out, "PaidCode: {0}", output.getPaidCode());
			print(out, "PaidContents: {0}", output.getPaidContents());
			print(out, "DocomoAcceptCode: {0}", output.getDocomoAcceptCode());
			print(out, "AuAcceptCode: {0}", output.getAuAcceptCode());
			print(out, "SbAcceptCode: {0}", output.getSbAcceptCode());
			print(out, "PaysleDisplayTerm: {0}", output.getPaysleDisplayTerm());
			print(out, "PayslePaymentTerm: {0}", output.getPayslePaymentTerm());
			print(out, "PaysleNotifyTerm: {0}", output.getPaysleNotifyTerm());
			print(out, "PaysleOrderSerial: {0}", output.getPaysleOrderSerial());
			print(out, "PaysleBarcodeWidth: {0}", output.getPaysleBarcodeWidth());
			print(out, "PaysleBarcodeHeight: {0}", output.getPaysleBarcodeHeight());
			print(out, "PaysleBarcodeFormat: {0}", output.getPaysleBarcodeFormat());
			print(out, "PaysleBarcode: {0}", output.getPaysleBarcode());
			print(out, "FinishDate: {0}", output.getFinishDate());
			print(out, "GanbBankCode: {0}", output.getGanbBankCode());
			print(out, "GanbBankName: {0}", output.getGanbBankName());
			print(out, "GanbBranchCode: {0}", output.getGanbBranchCode());
			print(out, "GanbBranchName: {0}", output.getGanbBranchName());
			print(out, "GanbAccountType: {0}", output.getGanbAccountType());
			print(out, "GanbAccountNumber: {0}", output.getGanbAccountNumber());
			print(out, "GanbAccountHolderName: {0}", output.getGanbAccountHolderName());
			print(out, "GanbExpireDays: {0}", output.getGanbExpireDays());
			print(out, "GanbExpireDate: {0}", output.getGanbExpireDate());
			print(out, "GanbTradeReason: {0}", output.getGanbTradeReason());
			print(out, "GanbTradeClientName: {0}", output.getGanbTradeClientName());
			print(out, "GanbTotalTransferAmount: {0}", output.getGanbTotalTransferAmount());
			print(out, "GanbTotalTransferCount: {0}", output.getGanbTotalTransferCount());
			print(out, "GanbLatestTransferAmount: {0}", output.getGanbLatestTransferAmount());
			print(out, "GanbLatestTransferDate: {0}", output.getGanbLatestTransferDate());
			print(out, "GanbLatestTransferName: {0}", output.getGanbLatestTransferName());
			print(out, "GanbLatestTransferBankName: {0}", output.getGanbLatestTransferBankName());
			print(out, "AmazonOrderReferenceID: {0}", output.getAmazonOrderReferenceID());
			print(out, "AmazonPayCancelAmount: {0}", output.getAmazonPayCancelAmount());
			print(out, "AmazonPayCancelTax: {0}", output.getAmazonPayCancelTax());
			print(out, "AmazonBillingAgreementID: {0}", output.getAmazonBillingAgreementID());
			print(out, "UriageNO: {0}", output.getUriageNO());
			print(out, "AuthToken: {0}", output.getAuthToken());
			print(out, "EposTradeID: {0}", output.getEposTradeID());
			print(out, "EposUseCouponAmount: {0}", output.getEposUseCouponAmount());
			print(out, "EposUsePoint: {0}", output.getEposUsePoint());
			print(out, "TotalCancelAmount: {0}", output.getTotalCancelAmount());
			print(out, "TotalCancelTax: {0}", output.getTotalCancelTax());
			print(out, "MerpayCancelAmount: {0}", output.getMerpayCancelAmount());
			print(out, "MerpayCancelTax: {0}", output.getMerpayCancelTax());
			print(out, "MerpayInquiryCode: {0}", output.getMerpayInquiryCode());
			print(out, "MerpaySubscriptionType: {0}", output.getMerpaySubscriptionType());
			print(out, "MerpaySubscriptionId: {0}", output.getMerpaySubscriptionId());
			print(out, "MerpaySubscriptionCurrentStatus: {0}", output.getMerpaySubscriptionCurrentStatus());
			print(out, "MerpaySubscriptionStartDate: {0}", output.getMerpaySubscriptionStartDate());
			print(out, "MerpaySubscriptionEndDate: {0}", output.getMerpaySubscriptionEndDate());
			print(out, "MerpaySettlementSubscriptionId: {0}", output.getMerpaySettlementSubscriptionId());
			print(out, "PostpayCancelAmount: {0}", output.getPostpayCancelAmount());
			print(out, "PostpayCancelTax: {0}", output.getPostpayCancelTax());
			print(out, "PostpayTransactionId: {0}", output.getPostpayTransactionId());
			print(out, "PostpayCreditResultManualReason: {0}", output.getPostpayCreditResultManualReason());
			print(out, "ForceCancelDate: {0}", output.getForceCancelDate());
			print(out, "PostpayPaymentStatus: {0}", output.getPostpayPaymentStatus());
			print(out, "PostpayPaymentDateFast: {0}", output.getPostpayPaymentDateFast());
			print(out, "PostpayPaymentDateConf: {0}", output.getPostpayPaymentDateConf());
			print(out, "PayPayCancelAmount: {0}", output.getPayPayCancelAmount());
			print(out, "PayPayCancelTax: {0}", output.getPayPayCancelTax());
			print(out, "PayPayTrackingID: {0}", output.getPayPayTrackingID());
			print(out, "PayPayOrderID: {0}", output.getPayPayOrderID());
			print(out, "PayPayAcceptCode: {0}", output.getPayPayAcceptCode());
			print(out, "AupayCancelAmount: {0}", output.getAupayCancelAmount());
			print(out, "AupayCancelTax: {0}", output.getAupayCancelTax());
			print(out, "RakutenChargeID: {0}", output.getRakutenChargeID());
			print(out, "ReauthLimitDate: {0}", output.getReauthLimitDate());
			print(out, "SalesLimitDate: {0}", output.getSalesLimitDate());
			print(out, "ChangeLimitDate: {0}", output.getChangeLimitDate());
			print(out, "CancelLimitDate: {0}", output.getCancelLimitDate());
			print(out, "RakutenPoint: {0}", output.getRakutenPoint());
			print(out, "RakutenSubscriptionType: {0}", output.getRakutenSubscriptionType());
			print(out, "RakutenSubscriptionID: {0}", output.getRakutenSubscriptionID());
			print(out, "RakutenSettlementSubscriptionID: {0}", output.getRakutenSettlementSubscriptionID());
			print(out, "RakutenSubscriptionCurrentStatus: {0}", output.getRakutenSubscriptionCurrentStatus());
			print(out, "RakutenSubscriptionStartDate: {0}", output.getRakutenSubscriptionStartDate());
			print(out, "RakutenSubscriptionAmount: {0}", output.getRakutenSubscriptionAmount());
			print(out, "AupayAppTranID: {0}", output.getAupayAppTranID());
			print(out, "AupayAppVoucherNo: {0}", output.getAupayAppVoucherNo());
			print(out, "AupayAppSeqNo: {0}", output.getAupayAppSeqNo());
			print(out, "AupayAppCancelAmount: {0}", output.getAupayAppCancelAmount());
			print(out, "AupayAppCancelTax: {0}", output.getAupayAppCancelTax());
			print(out, "AupayAppIncreaseAmount: {0}", output.getAupayAppIncreaseAmount());
			print(out, "AupayAppIncreaseTax: {0}", output.getAupayAppIncreaseTax());
			print(out, "BankCode: {0}", output.getBankCode());
			print(out, "BranchCode: {0}", output.getBranchCode());
			print(out, "AccountType: {0}", output.getAccountType());
			print(out, "AccountNumber: {0}", output.getAccountNumber());
			print(out, "AccountName: {0}", output.getAccountName());

		}
		out.flush();
}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
