package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.SiftEventsInput;
import com.gmo_pg.g_pay.client.output.SiftEventsOutput;
import com.gmo_pg.g_pay.client.output.ErrHolder;



/**
 * siftイベント実行呼出サーブレットサンプルクラス
 */
public class CallSiftEventsServlet extends HttpServlet {

	private static final String P_SHOP_ID = "ShopID";
	private static final String P_SHOP_PASS = "ShopPass";
	private static final String P_TYPE = "Type";
	private static final String P_USER_ID = "UserId";
	private static final String P_SESSION_ID = "SessionId";
	private static final String P_ORDER_ID = "OrderID";
	private static final String P_USER_EMAIL = "UserEmail";
	private static final String P_MEMBER_ID = "MemberID";
	private static final String P_SITE_ID = "SiteID";
	private static final String P_SITE_PASS = "SitePass";
	private static final String P_SEQ_MODE = "SeqMode";
	private static final String P_CARD_SEQ = "CardSeq";
	private static final String P_TOKEN = "Token";
	private static final String P_AMOUNT = "Amount";
	private static final String P_CURRENCY_CODE = "CurrencyCode";
	private static final String P_BILLING_ADDRESS_NAME = "BillingAddress_Name";
	private static final String P_BILLING_ADDRESS_ADDRESS1 = "BillingAddress_Address1";
	private static final String P_BILLING_ADDRESS_ADDRESS2 = "BillingAddress_Address2";
	private static final String P_BILLING_ADDRESS_CITY = "BillingAddress_City";
	private static final String P_BILLING_ADDRESS_REGION = "BillingAddress_Region";
	private static final String P_BILLING_ADDRESS_COUNTRY = "BillingAddress_Country";
	private static final String P_BILLING_ADDRESS_ZIPCODE = "BillingAddress_Zipcode";
	private static final String P_BILLING_ADDRESS_PHONE = "BillingAddress_Phone";
	private static final String P_PAYMENT_METHODS_PAYMENT_TYPE = "PaymentMethods_PaymentType";
	private static final String P_PAYMENT_METHODS_CARD_BIN = "PaymentMethods_CardBin";
	private static final String P_PAYMENT_METHODS_CARD_LAST4 = "PaymentMethods_CardLast4";
	private static final String P_PAYMENT_METHODS_VERIFICATION_STATUS = "PaymentMethods_VerificationStatus";
	private static final String P_PAYMENT_METHODS_ROUTING_NUMBER = "PaymentMethods_RoutingNumber";
	private static final String P_PAYMENT_METHODS_DECLINE_REASON_CODE = "PaymentMethods_DeclineReasonCode";
	private static final String P_PAYMENT_METHOD_PAYMENT_TYPE = "PaymentMethod_PaymentType";
	private static final String P_PAYMENT_METHOD_CARD_BIN = "PaymentMethod_CardBin";
	private static final String P_PAYMENT_METHOD_CARD_LAST4 = "PaymentMethod_CardLast4";
	private static final String P_PAYMENT_METHOD_VERIFICATION_STATUS = "PaymentMethod_VerificationStatus";
	private static final String P_PAYMENT_METHOD_ROUTING_NUMBER = "PaymentMethod_RoutingNumber";
	private static final String P_PAYMENT_METHOD_DECLINE_REASON_CODE = "PaymentMethod_DeclineReasonCode";
	private static final String P_SHIPPING_ADDRESS_NAME = "ShippingAddress_Name";
	private static final String P_SHIPPING_ADDRESS_ADDRESS1 = "ShippingAddress_Address1";
	private static final String P_SHIPPING_ADDRESS_ADDRESS2 = "ShippingAddress_Address2";
	private static final String P_SHIPPING_ADDRESS_CITY = "ShippingAddress_City";
	private static final String P_SHIPPING_ADDRESS_REGION = "ShippingAddress_Region";
	private static final String P_SHIPPING_ADDRESS_COUNTRY = "ShippingAddress_Country";
	private static final String P_SHIPPING_ADDRESS_ZIPCODE = "ShippingAddress_Zipcode";
	private static final String P_SHIPPING_ADDRESS_PHONE = "ShippingAddress_Phone";
	private static final String P_EXPEDITED_SHIPPING = "ExpeditedShipping";
	private static final String P_ITEMS_ITEM_ID = "Items_ItemId";
	private static final String P_ITEMS_PRODUCT_TITLE = "Items_ProductTitle";
	private static final String P_ITEMS_PRICE = "Items_Price";
	private static final String P_ITEMS_CURRENCY_CODE = "Items_CurrencyCode";
	private static final String P_ITEMS_QUANTITY = "Items_Quantity";
	private static final String P_ITEMS_UPC = "Items_Upc";
	private static final String P_ITEMS_SKU = "Items_Sku";
	private static final String P_ITEMS_ISBN = "Items_Isbn";
	private static final String P_ITEMS_BRAND = "Items_Brand";
	private static final String P_ITEMS_MANUFACTURER = "Items_Manufacturer";
	private static final String P_ITEMS_CATEGORY = "Items_Category";
	private static final String P_ITEMS_TAGS = "Items_Tags";
	private static final String P_ITEMS_COLOR = "Items_Color";
	private static final String P_ITEMS_SIZE = "Items_Size";
	private static final String P_BOOKINGS_BOOKING_TYPE = "Bookings_BookingType";
	private static final String P_BOOKINGS_TITLE = "Bookings_Title";
	private static final String P_BOOKINGS_START_TIME = "Bookings_StartTime";
	private static final String P_BOOKINGS_END_TIME = "Bookings_EndTime";
	private static final String P_BOOKINGS_PRICE = "Bookings_Price";
	private static final String P_BOOKINGS_CURRENCY_CODE = "Bookings_CurrencyCode";
	private static final String P_BOOKINGS_QUANTITY = "Bookings_Quantity";
	private static final String P_BOOKINGS_GUESTS_NAME = "Bookings_Guests_Name";
	private static final String P_BOOKINGS_GUESTS_EMAIL = "Bookings_Guests_Email";
	private static final String P_BOOKINGS_GUESTS_PHONE = "Bookings_Guests_Phone";
	private static final String P_BOOKINGS_GUESTS_LOYALTY_PROGRAM = "Bookings_Guests_LoyaltyProgram";
	private static final String P_BOOKINGS_GUESTS_LOYALTY_PROGRAM_ID = "Bookings_Guests_LoyaltyProgramId";
	private static final String P_BOOKINGS_GUESTS_BIRTH_DATE = "Bookings_Guests_BirthDate";
	private static final String P_BOOKINGS_EVENT_ID = "Bookings_EventId";
	private static final String P_BOOKINGS_VENUE_ID = "Bookings_VenueId";
	private static final String P_BOOKINGS_LOCATION_NAME = "Bookings_Location_Name";
	private static final String P_BOOKINGS_LOCATION_ADDRESS1 = "Bookings_Location_Address1";
	private static final String P_BOOKINGS_LOCATION_ADDRESS2 = "Bookings_Location_Address2";
	private static final String P_BOOKINGS_LOCATION_CITY = "Bookings_Location_City";
	private static final String P_BOOKINGS_LOCATION_REGION = "Bookings_Location_Region";
	private static final String P_BOOKINGS_LOCATION_COUNTRY = "Bookings_Location_Country";
	private static final String P_BOOKINGS_LOCATION_ZIPCODE = "Bookings_Location_Zipcode";
	private static final String P_BOOKINGS_LOCATION_PHONE = "Bookings_Location_Phone";
	private static final String P_BOOKINGS_CATEGORY = "Bookings_Category";
	private static final String P_BOOKINGS_TAGS = "Bookings_Tags";
	private static final String P_BOOKINGS_ROOM_TYPE = "Bookings_RoomType";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_NAME = "Bookings_Segments_DepartureAddress_Name";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_ADDRESS1 = "Bookings_Segments_DepartureAddress_Address1";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_ADDRESS2 = "Bookings_Segments_DepartureAddress_Address2";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_CITY = "Bookings_Segments_DepartureAddress_City";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_REGION = "Bookings_Segments_DepartureAddress_Region";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_COUNTRY = "Bookings_Segments_DepartureAddress_Country";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_ZIPCODE = "Bookings_Segments_DepartureAddress_Zipcode";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_PHONE = "Bookings_Segments_DepartureAddress_Phone";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_NAME = "Bookings_Segments_ArrivalAddress_Name";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_ADDRESS1 = "Bookings_Segments_ArrivalAddress_Address1";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_ADDRESS2 = "Bookings_Segments_ArrivalAddress_Address2";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_CITY = "Bookings_Segments_ArrivalAddress_City";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_REGION = "Bookings_Segments_ArrivalAddress_Region";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_COUNTRY = "Bookings_Segments_ArrivalAddress_Country";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_ZIPCODE = "Bookings_Segments_ArrivalAddress_Zipcode";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_PHONE = "Bookings_Segments_ArrivalAddress_Phone";
	private static final String P_BOOKINGS_SEGMENTS_START_TIME = "Bookings_Segments_StartTime";
	private static final String P_BOOKINGS_SEGMENTS_END_TIME = "Bookings_Segments_EndTime";
	private static final String P_BOOKINGS_SEGMENTS_VESSEL_NUMBER = "Bookings_Segments_VesselNumber";
	private static final String P_BOOKINGS_SEGMENTS_DEPARTURE_AIRPORT_CODE = "Bookings_Segments_DepartureAirportCode";
	private static final String P_BOOKINGS_SEGMENTS_ARRIVAL_AIRPORT_CODE = "Bookings_Segments_ArrivalAirportCode";
	private static final String P_BOOKINGS_SEGMENTS_FARE_CLASS = "Bookings_Segments_FareClass";
	private static final String P_SELLER_USER_ID = "SellerUserId";
	private static final String P_PROMOTIONS_PROMOTION_ID = "Promotions_PromotionId";
	private static final String P_PROMOTIONS_STATUS = "Promotions_Status";
	private static final String P_PROMOTIONS_FAILURE_REASON = "Promotions_FailureReason";
	private static final String P_PROMOTIONS_DESCRIPTION = "Promotions_Description";
	private static final String P_PROMOTIONS_REFERRER_USER_ID = "Promotions_ReferrerUserId";
	private static final String P_PROMOTIONS_DISCOUNT_PERCENTAGE_OFF = "Promotions_Discount_PercentageOff";
	private static final String P_PROMOTIONS_DISCOUNT_AMOUNT = "Promotions_Discount_Amount";
	private static final String P_PROMOTIONS_DISCOUNT_CURRENCY_CODE = "Promotions_Discount_CurrencyCode";
	private static final String P_PROMOTIONS_DISCOUNT_MINIMUM_PURCHASE_AMOUNT = "Promotions_Discount_MinimumPurchaseAmount";
	private static final String P_PROMOTIONS_CREDIT_POINT_AMOUNT = "Promotions_CreditPoint_Amount";
	private static final String P_PROMOTIONS_CREDIT_POINT_CREDIT_POINT_TYPE = "Promotions_CreditPoint_CreditPointType";
	private static final String P_SHIPPING_METHOD = "ShippingMethod";
	private static final String P_BROWSER_USER_AGENT = "Browser_UserAgent";
	private static final String P_APP_OS = "App_Os";
	private static final String P_APP_OS_VERSION = "App_OsVersion";
	private static final String P_APP_DEVICE_MANUFACTURER = "App_DeviceManufacturer";
	private static final String P_APP_DEVICE_MODEL = "App_DeviceModel";
	private static final String P_APP_DEVICE_UNIQUE_ID = "App_DeviceUniqueId";
	private static final String P_APP_APP_NAME = "App_AppName";
	private static final String P_APP_APP_VERSION = "App_AppVersion";
	private static final String P_TRANSACTION_TYPE = "TransactionType";
	private static final String P_TRANSACTION_STATUS = "TransactionStatus";
	private static final String P_DECLINE_CATEGORY = "DeclineCategory";
	private static final String P_TRANSFER_RECIPIENT_USER_ID = "TransferRecipientUserId";
	private static final String P_CHARGEBACK_STATE = "ChargebackState";
	private static final String P_CHARGEBACK_REASON = "ChargebackReason";
	private static final String P_DECISION_ID = "DecisionId";
	private static final String P_SOURCE = "Source";
	private static final String P_ANALYST = "Analyst";
	private static final String P_TIME = "Time";
	private static final String P_DESCRIPTION = "Description";
	private static final String P_IP = "Ip";
	private static final String P_SIFT_ORDER_ID = "SiftOrderID";
	private static final String P_CLIENT_FIELD1 = "ClientField1";
	private static final String P_CLIENT_FIELD2 = "ClientField2";
	private static final String P_CLIENT_FIELD3 = "ClientField3";
	private static final String P_PAY_TYPE = "PayType";


	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
    	throws ServletException, IOException {

        req.setCharacterEncoding("windows-31j");
        res.setContentType("text/html; charset=windows-31j");
        PrintWriter out = res.getWriter();

        PaymentClientImpl client = new PaymentClientImpl();
        SiftEventsInput input = new SiftEventsInput();
        SiftEventsOutput output = null;

        // パラメータの設定
		input.setShopID(req.getParameter(P_SHOP_ID));
		input.setShopPass(req.getParameter(P_SHOP_PASS));
		input.setType(req.getParameter(P_TYPE));
		input.setUserId(req.getParameter(P_USER_ID));
		input.setSessionId(req.getParameter(P_SESSION_ID));
		input.setOrderID(req.getParameter(P_ORDER_ID));
		input.setUserEmail(req.getParameter(P_USER_EMAIL));
		input.setMemberID(req.getParameter(P_MEMBER_ID));
		input.setSiteID(req.getParameter(P_SITE_ID));
		input.setSitePass(req.getParameter(P_SITE_PASS));
		input.setSeqMode(req.getParameter(P_SEQ_MODE));
		input.setCardSeq(req.getParameter(P_CARD_SEQ));
		input.setToken(req.getParameter(P_TOKEN));
		input.setAmount(req.getParameter(P_AMOUNT));
		input.setCurrencyCode(req.getParameter(P_CURRENCY_CODE));
		input.setBillingAddress_Name(req.getParameter(P_BILLING_ADDRESS_NAME));
		input.setBillingAddress_Address1(req.getParameter(P_BILLING_ADDRESS_ADDRESS1));
		input.setBillingAddress_Address2(req.getParameter(P_BILLING_ADDRESS_ADDRESS2));
		input.setBillingAddress_City(req.getParameter(P_BILLING_ADDRESS_CITY));
		input.setBillingAddress_Region(req.getParameter(P_BILLING_ADDRESS_REGION));
		input.setBillingAddress_Country(req.getParameter(P_BILLING_ADDRESS_COUNTRY));
		input.setBillingAddress_Zipcode(req.getParameter(P_BILLING_ADDRESS_ZIPCODE));
		input.setBillingAddress_Phone(req.getParameter(P_BILLING_ADDRESS_PHONE));
		input.setPaymentMethods_PaymentType(req.getParameter(P_PAYMENT_METHODS_PAYMENT_TYPE));
		input.setPaymentMethods_CardBin(req.getParameter(P_PAYMENT_METHODS_CARD_BIN));
		input.setPaymentMethods_CardLast4(req.getParameter(P_PAYMENT_METHODS_CARD_LAST4));
		input.setPaymentMethods_VerificationStatus(req.getParameter(P_PAYMENT_METHODS_VERIFICATION_STATUS));
		input.setPaymentMethods_RoutingNumber(req.getParameter(P_PAYMENT_METHODS_ROUTING_NUMBER));
		input.setPaymentMethods_DeclineReasonCode(req.getParameter(P_PAYMENT_METHODS_DECLINE_REASON_CODE));
		input.setPaymentMethod_PaymentType(req.getParameter(P_PAYMENT_METHOD_PAYMENT_TYPE));
		input.setPaymentMethod_CardBin(req.getParameter(P_PAYMENT_METHOD_CARD_BIN));
		input.setPaymentMethod_CardLast4(req.getParameter(P_PAYMENT_METHOD_CARD_LAST4));
		input.setPaymentMethod_VerificationStatus(req.getParameter(P_PAYMENT_METHOD_VERIFICATION_STATUS));
		input.setPaymentMethod_RoutingNumber(req.getParameter(P_PAYMENT_METHOD_ROUTING_NUMBER));
		input.setPaymentMethod_DeclineReasonCode(req.getParameter(P_PAYMENT_METHOD_DECLINE_REASON_CODE));
		input.setShippingAddress_Name(req.getParameter(P_SHIPPING_ADDRESS_NAME));
		input.setShippingAddress_Address1(req.getParameter(P_SHIPPING_ADDRESS_ADDRESS1));
		input.setShippingAddress_Address2(req.getParameter(P_SHIPPING_ADDRESS_ADDRESS2));
		input.setShippingAddress_City(req.getParameter(P_SHIPPING_ADDRESS_CITY));
		input.setShippingAddress_Region(req.getParameter(P_SHIPPING_ADDRESS_REGION));
		input.setShippingAddress_Country(req.getParameter(P_SHIPPING_ADDRESS_COUNTRY));
		input.setShippingAddress_Zipcode(req.getParameter(P_SHIPPING_ADDRESS_ZIPCODE));
		input.setShippingAddress_Phone(req.getParameter(P_SHIPPING_ADDRESS_PHONE));
		input.setExpeditedShipping(req.getParameter(P_EXPEDITED_SHIPPING));
		input.setItems_ItemId(req.getParameter(P_ITEMS_ITEM_ID));
		input.setItems_ProductTitle(req.getParameter(P_ITEMS_PRODUCT_TITLE));
		input.setItems_Price(req.getParameter(P_ITEMS_PRICE));
		input.setItems_CurrencyCode(req.getParameter(P_ITEMS_CURRENCY_CODE));
		input.setItems_Quantity(req.getParameter(P_ITEMS_QUANTITY));
		input.setItems_Upc(req.getParameter(P_ITEMS_UPC));
		input.setItems_Sku(req.getParameter(P_ITEMS_SKU));
		input.setItems_Isbn(req.getParameter(P_ITEMS_ISBN));
		input.setItems_Brand(req.getParameter(P_ITEMS_BRAND));
		input.setItems_Manufacturer(req.getParameter(P_ITEMS_MANUFACTURER));
		input.setItems_Category(req.getParameter(P_ITEMS_CATEGORY));
		input.setItems_Tags(req.getParameter(P_ITEMS_TAGS));
		input.setItems_Color(req.getParameter(P_ITEMS_COLOR));
		input.setItems_Size(req.getParameter(P_ITEMS_SIZE));
		input.setBookings_BookingType(req.getParameter(P_BOOKINGS_BOOKING_TYPE));
		input.setBookings_Title(req.getParameter(P_BOOKINGS_TITLE));
		input.setBookings_StartTime(req.getParameter(P_BOOKINGS_START_TIME));
		input.setBookings_EndTime(req.getParameter(P_BOOKINGS_END_TIME));
		input.setBookings_Price(req.getParameter(P_BOOKINGS_PRICE));
		input.setBookings_CurrencyCode(req.getParameter(P_BOOKINGS_CURRENCY_CODE));
		input.setBookings_Quantity(req.getParameter(P_BOOKINGS_QUANTITY));
		input.setBookings_Guests_Name(req.getParameter(P_BOOKINGS_GUESTS_NAME));
		input.setBookings_Guests_Email(req.getParameter(P_BOOKINGS_GUESTS_EMAIL));
		input.setBookings_Guests_Phone(req.getParameter(P_BOOKINGS_GUESTS_PHONE));
		input.setBookings_Guests_LoyaltyProgram(req.getParameter(P_BOOKINGS_GUESTS_LOYALTY_PROGRAM));
		input.setBookings_Guests_LoyaltyProgramId(req.getParameter(P_BOOKINGS_GUESTS_LOYALTY_PROGRAM_ID));
		input.setBookings_Guests_BirthDate(req.getParameter(P_BOOKINGS_GUESTS_BIRTH_DATE));
		input.setBookings_EventId(req.getParameter(P_BOOKINGS_EVENT_ID));
		input.setBookings_VenueId(req.getParameter(P_BOOKINGS_VENUE_ID));
		input.setBookings_Location_Name(req.getParameter(P_BOOKINGS_LOCATION_NAME));
		input.setBookings_Location_Address1(req.getParameter(P_BOOKINGS_LOCATION_ADDRESS1));
		input.setBookings_Location_Address2(req.getParameter(P_BOOKINGS_LOCATION_ADDRESS2));
		input.setBookings_Location_City(req.getParameter(P_BOOKINGS_LOCATION_CITY));
		input.setBookings_Location_Region(req.getParameter(P_BOOKINGS_LOCATION_REGION));
		input.setBookings_Location_Country(req.getParameter(P_BOOKINGS_LOCATION_COUNTRY));
		input.setBookings_Location_Zipcode(req.getParameter(P_BOOKINGS_LOCATION_ZIPCODE));
		input.setBookings_Location_Phone(req.getParameter(P_BOOKINGS_LOCATION_PHONE));
		input.setBookings_Category(req.getParameter(P_BOOKINGS_CATEGORY));
		input.setBookings_Tags(req.getParameter(P_BOOKINGS_TAGS));
		input.setBookings_RoomType(req.getParameter(P_BOOKINGS_ROOM_TYPE));
		input.setBookings_Segments_DepartureAddress_Name(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_NAME));
		input.setBookings_Segments_DepartureAddress_Address1(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_ADDRESS1));
		input.setBookings_Segments_DepartureAddress_Address2(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_ADDRESS2));
		input.setBookings_Segments_DepartureAddress_City(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_CITY));
		input.setBookings_Segments_DepartureAddress_Region(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_REGION));
		input.setBookings_Segments_DepartureAddress_Country(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_COUNTRY));
		input.setBookings_Segments_DepartureAddress_Zipcode(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_ZIPCODE));
		input.setBookings_Segments_DepartureAddress_Phone(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_ADDRESS_PHONE));
		input.setBookings_Segments_ArrivalAddress_Name(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_NAME));
		input.setBookings_Segments_ArrivalAddress_Address1(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_ADDRESS1));
		input.setBookings_Segments_ArrivalAddress_Address2(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_ADDRESS2));
		input.setBookings_Segments_ArrivalAddress_City(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_CITY));
		input.setBookings_Segments_ArrivalAddress_Region(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_REGION));
		input.setBookings_Segments_ArrivalAddress_Country(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_COUNTRY));
		input.setBookings_Segments_ArrivalAddress_Zipcode(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_ZIPCODE));
		input.setBookings_Segments_ArrivalAddress_Phone(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_ADDRESS_PHONE));
		input.setBookings_Segments_StartTime(req.getParameter(P_BOOKINGS_SEGMENTS_START_TIME));
		input.setBookings_Segments_EndTime(req.getParameter(P_BOOKINGS_SEGMENTS_END_TIME));
		input.setBookings_Segments_VesselNumber(req.getParameter(P_BOOKINGS_SEGMENTS_VESSEL_NUMBER));
		input.setBookings_Segments_DepartureAirportCode(req.getParameter(P_BOOKINGS_SEGMENTS_DEPARTURE_AIRPORT_CODE));
		input.setBookings_Segments_ArrivalAirportCode(req.getParameter(P_BOOKINGS_SEGMENTS_ARRIVAL_AIRPORT_CODE));
		input.setBookings_Segments_FareClass(req.getParameter(P_BOOKINGS_SEGMENTS_FARE_CLASS));
		input.setSellerUserId(req.getParameter(P_SELLER_USER_ID));
		input.setPromotions_PromotionId(req.getParameter(P_PROMOTIONS_PROMOTION_ID));
		input.setPromotions_Status(req.getParameter(P_PROMOTIONS_STATUS));
		input.setPromotions_FailureReason(req.getParameter(P_PROMOTIONS_FAILURE_REASON));
		input.setPromotions_Description(req.getParameter(P_PROMOTIONS_DESCRIPTION));
		input.setPromotions_ReferrerUserId(req.getParameter(P_PROMOTIONS_REFERRER_USER_ID));
		input.setPromotions_Discount_PercentageOff(req.getParameter(P_PROMOTIONS_DISCOUNT_PERCENTAGE_OFF));
		input.setPromotions_Discount_Amount(req.getParameter(P_PROMOTIONS_DISCOUNT_AMOUNT));
		input.setPromotions_Discount_CurrencyCode(req.getParameter(P_PROMOTIONS_DISCOUNT_CURRENCY_CODE));
		input.setPromotions_Discount_MinimumPurchaseAmount(req.getParameter(P_PROMOTIONS_DISCOUNT_MINIMUM_PURCHASE_AMOUNT));
		input.setPromotions_CreditPoint_Amount(req.getParameter(P_PROMOTIONS_CREDIT_POINT_AMOUNT));
		input.setPromotions_CreditPoint_CreditPointType(req.getParameter(P_PROMOTIONS_CREDIT_POINT_CREDIT_POINT_TYPE));
		input.setShippingMethod(req.getParameter(P_SHIPPING_METHOD));
		input.setBrowser_UserAgent(req.getParameter(P_BROWSER_USER_AGENT));
		input.setApp_Os(req.getParameter(P_APP_OS));
		input.setApp_OsVersion(req.getParameter(P_APP_OS_VERSION));
		input.setApp_DeviceManufacturer(req.getParameter(P_APP_DEVICE_MANUFACTURER));
		input.setApp_DeviceModel(req.getParameter(P_APP_DEVICE_MODEL));
		input.setApp_DeviceUniqueId(req.getParameter(P_APP_DEVICE_UNIQUE_ID));
		input.setApp_AppName(req.getParameter(P_APP_APP_NAME));
		input.setApp_AppVersion(req.getParameter(P_APP_APP_VERSION));
		input.setTransactionType(req.getParameter(P_TRANSACTION_TYPE));
		input.setTransactionStatus(req.getParameter(P_TRANSACTION_STATUS));
		input.setDeclineCategory(req.getParameter(P_DECLINE_CATEGORY));
		input.setTransferRecipientUserId(req.getParameter(P_TRANSFER_RECIPIENT_USER_ID));
		input.setChargebackState(req.getParameter(P_CHARGEBACK_STATE));
		input.setChargebackReason(req.getParameter(P_CHARGEBACK_REASON));
		input.setDecisionId(req.getParameter(P_DECISION_ID));
		input.setSource(req.getParameter(P_SOURCE));
		input.setAnalyst(req.getParameter(P_ANALYST));
		input.setTime(req.getParameter(P_TIME));
		input.setDescription(req.getParameter(P_DESCRIPTION));
		input.setIp(req.getParameter(P_IP));
		input.setSiftOrderID(req.getParameter(P_SIFT_ORDER_ID));
		input.setClientField1(req.getParameter(P_CLIENT_FIELD1));
		input.setClientField2(req.getParameter(P_CLIENT_FIELD2));
		input.setClientField3(req.getParameter(P_CLIENT_FIELD3));
		input.setPayType(req.getParameter(P_PAY_TYPE));

       	print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doSiftEvents(input);
		} catch (PaymentException e) {
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {
			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, "ErrorCode: {0}  ErrorInfo: {1}",
						new Object[]{eh.getErrCode(), eh.getErrInfo()});
			}
		} else {
			print(out, "OUTPUT:");
			print(out, "SiftOrderID: {0}", output.getSiftOrderID());
			print(out, "PaymentAbuseScore: {0}", output.getPaymentAbuseScore());

		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
