package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;
import com.gmo_pg.g_pay.client.input.Tds2AuthAppInput;
import com.gmo_pg.g_pay.client.output.ErrHolder;
import com.gmo_pg.g_pay.client.output.Tds2AuthAppOutput;

/**
 * 3DS2.0認証実行（モバイルアプリ版）呼出サーブレットサンプルクラス
 */
public class CallTds2AuthAppServlet extends HttpServlet {

	private static final String P_ACCESS_ID = "AccessID";
	private static final String P_ACCESS_PASS = "AccessPass";
	private static final String P_TDS2_SDK_INTERFACE = "Tds2SdkInterface";
	private static final String P_TDS2_SDK_UI_TYPE = "Tds2SdkUiType";
	private static final String P_TDS2_SDK_APP_ID = "Tds2SdkAppID";
	private static final String P_TDS2_ENC_DATA = "Tds2EncData";
	private static final String P_TDS2_SDK_JWK_ALG = "Tds2SdkJwkAlg";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_SIGN = "Tds2SdkJwkKeyOpsSign";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_VERIFY = "Tds2SdkJwkKeyOpsVerify";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_ENCRYPT = "Tds2SdkJwkKeyOpsEncrypt";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_DECRYPT = "Tds2SdkJwkKeyOpsDecrypt";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_WRAP_KEY = "Tds2SdkJwkKeyOpsWrapKey";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_UNWRAP_KEY = "Tds2SdkJwkKeyOpsUnwrapKey";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_DERIVE_KEY = "Tds2SdkJwkKeyOpsDeriveKey";
	private static final String P_TDS2_SDK_JWK_KEY_OPS_DERIVE_BITS = "Tds2SdkJwkKeyOpsDeriveBits";
	private static final String P_TDS2_SDK_JWK_KID = "Tds2SdkJwkKid";
	private static final String P_TDS2_SDK_JWK_KTY = "Tds2SdkJwkKty";
	private static final String P_TDS2_SDK_JWK_USE = "Tds2SdkJwkUse";
	private static final String P_TDS2_SDK_JWK_X5C = "Tds2SdkJwkX5c";
	private static final String P_TDS2_SDK_JWK_X5T = "Tds2SdkJwkX5t";
	private static final String P_TDS2_SDK_JWK_X5U = "Tds2SdkJwkX5u";
	private static final String P_TDS2_SDK_MAX_TIMEOUT = "Tds2SdkMaxTimeout";
	private static final String P_TDS2_SDK_REFERENCE_NUMBER = "Tds2SdkReferenceNumber";
	private static final String P_TDS2_SDK_TRANS_ID = "Tds2SdkTransID";

	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		doPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		Tds2AuthAppInput input = new Tds2AuthAppInput();
		Tds2AuthAppOutput output = null;

		// パラメータの設定
		input.setAccessId(req.getParameter(P_ACCESS_ID));
		input.setAccessPass(req.getParameter(P_ACCESS_PASS));
		input.setTds2SdkInterface(req.getParameter(P_TDS2_SDK_INTERFACE));
		input.setTds2SdkUiType(req.getParameter(P_TDS2_SDK_UI_TYPE));
		input.setTds2SdkAppID(req.getParameter(P_TDS2_SDK_APP_ID));
		input.setTds2EncData(req.getParameter(P_TDS2_ENC_DATA));
		input.setTds2SdkJwkAlg(req.getParameter(P_TDS2_SDK_JWK_ALG));
		input.setTds2SdkJwkKeyOpsSign(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_SIGN));
		input.setTds2SdkJwkKeyOpsVerify(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_VERIFY));
		input.setTds2SdkJwkKeyOpsEncrypt(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_ENCRYPT));
		input.setTds2SdkJwkKeyOpsDecrypt(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_DECRYPT));
		input.setTds2SdkJwkKeyOpsWrapKey(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_WRAP_KEY));
		input.setTds2SdkJwkKeyOpsUnwrapKey(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_UNWRAP_KEY));
		input.setTds2SdkJwkKeyOpsDeriveKey(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_DERIVE_KEY));
		input.setTds2SdkJwkKeyOpsDeriveBits(req.getParameter(P_TDS2_SDK_JWK_KEY_OPS_DERIVE_BITS));
		input.setTds2SdkJwkKid(req.getParameter(P_TDS2_SDK_JWK_KID));
		input.setTds2SdkJwkKty(req.getParameter(P_TDS2_SDK_JWK_KTY));
		input.setTds2SdkJwkUse(req.getParameter(P_TDS2_SDK_JWK_USE));
		input.setTds2SdkJwkX5c(req.getParameter(P_TDS2_SDK_JWK_X5C));
		input.setTds2SdkJwkX5t(req.getParameter(P_TDS2_SDK_JWK_X5T));
		input.setTds2SdkJwkX5u(req.getParameter(P_TDS2_SDK_JWK_X5U));
		input.setTds2SdkMaxTimeout(req.getParameter(P_TDS2_SDK_MAX_TIMEOUT));
		input.setTds2SdkReferenceNumber(req.getParameter(P_TDS2_SDK_REFERENCE_NUMBER));
		input.setTds2SdkTransID(req.getParameter(P_TDS2_SDK_TRANS_ID));

		print(out, "INPUT: {0}", input.toDataString(false));

		try {
			// API呼び出し
			output = client.doTds2AuthApp(input);
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果確認
		if (output.isErrorOccurred()) {

			List list = output.getErrList();
			print(out, "ERROR:");
			for(Iterator it = list.iterator(); it.hasNext();) {
				ErrHolder eh = (ErrHolder)it.next();
				print(out, MessageFormat.format("ErrorCode: {0}  ErrorInfo: {1}",
								new Object[]{eh.getErrCode(), eh.getErrInfo()}));
			}
		} else {
			print(out, "OUTPUT:");
	        print(out, "Tds2TransResult: {0}", output.getTds2TransResult());
	        print(out, "Tds2TransResultReason: {0}", output.getTds2TransResultReason());
		}
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		print(out, str, null);
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[]{obj});
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt,obj));
		out.print(MessageFormat.format(fmt,obj));
		out.print("<br>");
		out.println();
	}
}
