package com.gmo_pg.g_pay.client.sample.call;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.gmo_pg.g_pay.client.common.PaymentException;
import com.gmo_pg.g_pay.client.impl.PaymentClientImpl;

/**
 * Webmoney支払開始サンプルサーブレットクラス
 *
 * @author GMO PaymentGateway
 * @modified 2010/04/08
 */
public class CallWebmoneyStartServlet extends HttpServlet {

	private static final String P_ACCESS_ID = "AccessID";

	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {

		req.setCharacterEncoding("windows-31j");
		res.setContentType("text/html; charset=windows-31j");
		PrintWriter out = res.getWriter();

		PaymentClientImpl client = new PaymentClientImpl();
		String output = null;

		// パラメータの設定
		String accessId = req.getParameter(P_ACCESS_ID);

		print(out, "INPUT: AccessID={0}", accessId);

		try {
			// API呼び出し
			output = client.doWebmoneyStart(
					"conf/DoWebmoneyStartRedirect.html", accessId,
					"Windows-31J");
		} catch (PaymentException e) {
			//
			// [注意事項]
			// エラーが発生した場合は、お手数ですが加盟店様側でエラー処理を行っていただくようお願い致します。
			//
			e.printStackTrace();
			throw new ServletException(e);
		}

		// 結果出力
		print(out, "OUTPUT:");
		print(out, output);
		out.flush();
	}

	private void print(PrintWriter out, String str) {
		System.out.println(str);
		out.print(str);
		out.println();
	}

	private void print(PrintWriter out, String fmt, Object obj) {
		print(out, fmt, new Object[] { obj });
	}

	private void print(PrintWriter out, String fmt, Object[] obj) {
		System.out.println(MessageFormat.format(fmt, obj));
		out.print(MessageFormat.format(fmt, obj));
		out.print("<br>");
		out.println();
	}
}